<?php
if ( ! defined( 'ABSPATH' ) ) exit; 

class DropshipCronProductUpdate
{
    private $plugin_name;
    private $version;
    private $license_no;
    private $domain;
    private $api_domain;
    private $data;

    public function __construct($dataArray)
    {
        $this->plugin_name = $dataArray['plugin_name'];
        $this->version = $dataArray['plugin_version'];
        $this->domain = $dataArray['plugin_domain'];
        $this->api_domain = $dataArray['api_domain'];
        $this->data = $dataArray;

        add_filter('cron_schedules', array($this,'mantella_update_cron_schedule'));
        //Schedule an action if it's not already scheduled
        if (! wp_next_scheduled('mantella_update_cron_job'))
        {
            wp_schedule_event(time(), 'every_twentyfour_hours', 'mantella_update_cron_job');
        }
        add_action('mantella_update_cron_job', array($this,'mantella_update_cron_function'));
    }

    //Setup scheduler
    public function mantella_update_cron_schedule($schedules)
    {
        $schedules['every_twentyfour_hours'] = array(
            'interval' => 86400,
            'display' => __('Every 24 Hrs'),
        );
        return $schedules;
    }

    public function mantella_update_cron_function()
    {
        global $wpdb;
        $this->record = $wpdb->get_results("select license_no from " . $wpdb->prefix . "license_key");
        $this->license_no = $this->record[0]->license_no;

        include_once(plugin_dir_path(__FILE__) . 'wp-product-stock.php');
        $ps = new DropshipProductStock($this->data);
        $ps->product_stock($this->license_no, $this->domain);
    }

}
