<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed 

class DropshipCronProductUpdateTrackingCode
{
    private $plugin_name;
    private $version;
    private $license_no;
    private $domain;
    private $api_domain;
    private $data;

    public function __construct($dataArray)
    {
        $this->plugin_name = $dataArray['plugin_name'];
        $this->version = $dataArray['plugin_version'];
        $this->domain = $dataArray['plugin_domain'];
        $this->api_domain = $dataArray['api_domain'];
        $this->data = $dataArray;

        add_filter('cron_schedules', array($this, 'mantella_custom_cron_schedule_trackupdate'));

        //Schedule an action if it's not already scheduled
        if (!wp_next_scheduled('mantella_cron_job_trackupdate')) {

            wp_schedule_event(time(), '12hrscron', 'mantella_cron_job_trackupdate');

        }

        add_action('mantella_cron_job_trackupdate', array($this, 'mantella_cron_trackupdate_function'));

    }

    //Setup scheduler
    public function mantella_custom_cron_schedule_trackupdate($schedules)
    {
        $schedules['12hrscron'] = array(
            'interval' => 60 * 60 * 12,
            'display' => __('Every 12 Hrs update'),
        );

        return $schedules;

    }

    public function mantella_cron_trackupdate_function()
    {
        global $wpdb;
        include_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
        $sql = 'SELECT * FROM `' . $wpdb->prefix . 'dropship_track_order_dtl`';
        $record = $wpdb->get_results($sql);

        foreach ($record as $rec) {
            $rec->woo_order_id;
            $rec->ds_order_id;
            $i = 1;
            $track_data = json_decode($rec->tracking_codes, TRUE);

            foreach ($track_data as $key => $td) {
                $this->mantella_cron_trackupdate_api_function($rec->woo_order_id, $rec->ds_order_id);
                $i++;
            }
            echo '<hr>';
        }
    }

    public function mantella_cron_trackupdate_api_function($woo_order_id, $ds_order_id)
    {
        global $wpdb;
        include_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
        $this->record = $wpdb->get_results("select `license_no` from " . $wpdb->prefix . "license_key");
        $this->license_no = $this->record[0]->license_no;
        $url = $this->api_domain . "feeds/" . $this->domain . "/" . $this->license_no . "/trackingcodes/" . $ds_order_id;

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_URL, $url);
        $result = curl_exec($ch);
        curl_close($ch);
        $track_data = json_decode($result, true);
        $tracking_codes = json_encode($track_data['data']['tracking_codes']);

        $Query = "UPDATE `" . $wpdb->prefix . "dropship_track_order_dtl` SET `tracking_codes`='" . $tracking_codes . "' WHERE `woo_order_id`='" . $woo_order_id . "'";
        $done = $wpdb->query($Query);
        $order = wc_get_order($woo_order_id);

        $status = 'Proccessing';
        if ($done) {
            $order_note = 'Your order ' . $status . ' status. ';
            $order->add_order_note($order_note);
        } else {
            echo 'not';
        }
    }

}
