<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class DropshipProductTabs
{
    private $plugin_name;
    private $version;
    private $domain;
    private $api_domain;

    public function __construct($dataArray)
    {
        $this->plugin_name = $dataArray['plugin_name'];
        $this->version = $dataArray['plugin_version'];
        $this->domain = $dataArray['plugin_domain'];
        $this->api_domain = $dataArray['api_domain'];

        add_filter('woocommerce_product_data_tabs', array($this,'product_data_tab'), 90, 1);
        add_action('admin_head', array($this,'wcpp_custom_style'));
        add_action('woocommerce_product_data_panels', array($this,'product_data_fields'));
        add_action('woocommerce_process_product_meta',array($this,'shipping_costs_process_product_meta_fields_save'));
        add_action('woocommerce_product_meta_start', array($this,'mantella_EAN_display_brand_before_title'), 10, 0 );

    }
 
    //TAB
    function product_data_tab( $product_data_tabs ) {

        global $post;      
        $product = wc_get_product( $post->ID );
        if($product && $product->get_type() === 'variable'){
            $className = 'dropship_tool';
        }
        $product_data_tabs['mantella-extra-tab'] = array(
            'label' => __('Dropship Tool', 'dropship-tool-by-mantella'), // translatable
            'target' => 'mantella_extra_product_data', // translatable
            'class'  => $className,
        );
        return $product_data_tabs;
    }

    //Style
    function wcpp_custom_style() { ?>    
        <style>
            .mantella-extra-tab_options.mantella-extra-tab_tab > a:after {
                content:"";
                position:absolute;
                background: url("<?php echo PLUGIN_DIR_URL . 'templates/assets/mantella_icon-hover.png'; ?>") no-repeat;
                background-position: center center;
                background-size: 75%;
                font-size:0px;
                background-color:#fafafa;
                left:8px;
                width:20px;
                height:20px;
                z-index:999;
            }

            .mantella-extra-tab_options.mantella-extra-tab_tab.active > a:after {

                background-color:#eee;

            }
            .cust_tab_flex {
                display:flex;
                align-items:center;

            }
            .cust_tab_flex .form-field {
                height:17px !important;
            }
            .cust_tab_flex > label {
                margin:0px !important;
                padding-left:13px !important;
            }
            ._mantella_ean_number_show_in_front_field {
                display:flex;
            }
            .wc-radios{
                display:flex !important;
            }
            .wc-radios li{
                flex:0 0 50px;
            }
        </style>
        <?php
    }

    //TAB Fields
    function product_data_fields() {
        global $post;
      
        echo '<style>fieldset.form-field._input_radio_field > legend{float:none;}</style>
        <div id="mantella_extra_product_data" class="panel woocommerce_options_panel">';

        //$readonly = array('readonly' => 'readonly'); //we can choose it if don't want to edit customer EAN number.
        $ean_number = get_post_meta( $post->ID, 'post_ean', true );
        $mantella_ean_number = get_post_meta( $post->ID, '_mantella_ean_number', true );
        $mantella_ean_number_val = !empty($mantella_ean_number) ? $mantella_ean_number : $ean_number;

        woocommerce_wp_text_input([
            'id' 				=> '_mantella_ean_number',
            'name'          	=> '_mantella_ean_number',
            'label' 			=> __('EAN code: ', 'dropship-tool-by-mantella'),
            'wrapper_class' 	=> 'show_if_simple',
            'desc_tip' 			=> 'true',
            'description' 		=> __( 'If you checked yes it will show in front end of your website.', 'dropship-tool-by-mantella'),
            //'custom_attributes' => $readonly,
            'value'				=> $mantella_ean_number_val
        ]);

        echo '<div class="cust_tab_flex"><label>' .__( 'View on frontend:','dropship-tool-by-mantella') .'</label>';
        // Radio Buttons field
        woocommerce_wp_radio( array(
            'id'            	=> '_mantella_ean_number_show_in_front',
            'name'          	=> '_mantella_ean_number_show_in_front',
            'wrapper_class' 	=> 'show_if_simple',
            'options'       	=> array(
                'Yes'       => __('Yes', 'dropship-tool-by-mantella'),
                'No'       	=> __('No', 'dropship-tool-by-mantella'),
            ),
        ) );
        echo '</div>';

        //Brand section
        $postbrand = get_post_meta( $post->ID, 'post_brand', true );
        $mantella_brand = get_post_meta( $post->ID, '_mantella_brand', true );
        $mantella_brand_val = !empty($mantella_brand) ? $mantella_brand : $postbrand;

        woocommerce_wp_text_input([
            'id' 				=> '_mantella_brand',
            'name'          	=> '_mantella_brand',
            'label' 			=> __('Brand: ', 'dropship-tool-by-mantella'),
            'wrapper_class' 	=> 'show_if_simple',
            'desc_tip' 			=> 'true',
            'description' 		=> __( 'If you checked yes it will show in front end of your website.', 'dropship-tool-by-mantella'),
            //'custom_attributes' => $readonly,
            'value'				=> $mantella_brand_val
        ]);

        echo '<div class="cust_tab_flex"><label>' .__( 'Brand view on frontend:','dropship-tool-by-mantella') .'</label>';
        // Radio Buttons field
        woocommerce_wp_radio( array(
            'id'            	=> '_mantella_brand_show_in_front',
            'name'          	=> '_mantella_brand_show_in_front',
            'wrapper_class' 	=> 'show_if_simple',
            'options'       	=> array(
                'Yes'       => __('Yes', 'dropship-tool-by-mantella'),
                'No'       	=> __('No', 'dropship-tool-by-mantella'),
            ),
        ) );
        echo '</div>';
        echo '</div>';
    }

    //TAB DATA SAVE
    function shipping_costs_process_product_meta_fields_save(){
        global $post;
        $post_id = $post->ID;
        //Condition for the EAN
        if(isset($_POST['_mantella_ean_number']))
        {
            //$ean_number = get_post_meta($post_id, 'post_ean', true);
            $mantella_ean_number = isset($_POST['_mantella_ean_number']) ? $_POST['_mantella_ean_number'] : '';
            update_post_meta( $post_id, '_mantella_ean_number', $mantella_ean_number );

            $mantella_ean_number_show_in_front = isset( $_POST['_mantella_ean_number_show_in_front'] ) && $_POST['_mantella_ean_number'] != '' ? $_POST['_mantella_ean_number_show_in_front'] : '';
            update_post_meta( $post_id, '_mantella_ean_number_show_in_front', $mantella_ean_number_show_in_front );
        }
        //Condition for the Brand
        if(isset($_POST['_mantella_brand']))
        {
            //$postbrand = get_post_meta($post_id, 'post_brand', true);
            $mantella_post_brand = isset($_POST['_mantella_brand']) ? $_POST['_mantella_brand'] : '';
            
            update_post_meta( $post_id, '_mantella_brand', $mantella_post_brand );

            $mantella_brand_show_in_front = isset( $_POST['_mantella_brand_show_in_front'] ) && $_POST['_mantella_brand'] != '' ? $_POST['_mantella_brand_show_in_front'] : '';
            update_post_meta( $post_id, '_mantella_brand_show_in_front', $mantella_brand_show_in_front );
        }
    }

    //Show in webfront
    function mantella_EAN_display_brand_before_title() {
        global $post, $wpdb;
        include_once( ABSPATH . 'wp-admin/includes/upgrade.php' );

        $record = $wpdb->get_results("SELECT `ean_show_in_front`, `brand_show_in_front` FROM " . $wpdb->prefix . "license_key");
        $ean_show_in_front = $record[0]->ean_show_in_front;

        echo'<div class="custom-data">';
        if(empty(get_post_meta( $post->ID, '_mantella_ean_number', true ))){
            $mantella_ean_number = get_post_meta($post->ID, 'post_ean', true);
        }else{
            $mantella_ean_number = get_post_meta( $post->ID, '_mantella_ean_number', true );
        }
        $mantella_ean_number_show_in_front = get_post_meta( $post->ID, '_mantella_ean_number_show_in_front', true );

        if($ean_show_in_front=='Yes') {
            if ($mantella_ean_number_show_in_front == "Yes") {
                echo '<p><br/>' . __('EAN code:', 'dropship-tool-by-mantella') . ' <span>' . $mantella_ean_number . '</span></p>';
            }
        }

        //for the brand display
        $brand_show_in_front = $record[0]->brand_show_in_front;
        if(empty(get_post_meta( $post->ID, '_mantella_brand', true ))){
            $mantella_brand = get_post_meta($post->ID, 'post_brand', true);
        }else{
            $mantella_brand = get_post_meta( $post->ID, '_mantella_brand', true );
        }
        $mantella_brand_show_in_front = get_post_meta( $post->ID, '_mantella_brand_show_in_front', true );
        
        //Label brand
        if($brand_show_in_front=='Yes') {
            if ($mantella_brand_show_in_front == "Yes") {
                echo '<p>' . __('Brand:', 'dropship-tool-by-mantella') . ' <span>' . $mantella_brand . '</span></p>';
            }
        }
        echo '</div>';
    }

} 
