<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class DropshipImportUpdateMethodWithTime
{
    private $plugin_name;
    private $version;
    private $language;
    private $license_no;
    private $domain;
    private $api_domain;
    private $data;

    public function __construct($dataArray)
    {
        $this->plugin_name  = $dataArray['plugin_name'];
        $this->version      = $dataArray['plugin_version'];
        $this->domain       = $dataArray['plugin_domain'];
        $this->api_domain   = $dataArray['api_domain'];

        $this->data = $dataArray;

        add_action('init', array($this,'callCronSchedulesUpdateAfterPluginActivate'));
    }

    //Setup scheduler
    public function mantella_custom_cron_schedule_trackupdate_bytime($schedules)
    {
        global $wpdb;
        include_once( ABSPATH . 'wp-admin/includes/upgrade.php' );

        $record = $wpdb->get_results("select time_var from " . $wpdb->prefix . "license_key");

        if(isset($record[0]->time_var) && $record[0]->time_var != 0)
            $timevar = $record[0]->time_var*60;
        else
            $timevar = 3600;

        $schedules['1hrsupdatecron'] = array(
            'interval' => $timevar,
            'display' => __('Every '.$timevar .' seconds'),
        );

        return $schedules;
    }

    public function mantella_cron_trackupdate_function_bytime()
    {
        global $wpdb;
        include_once( ABSPATH . 'wp-admin/includes/upgrade.php' );

        $record = $wpdb->get_results("select time_var from " . $wpdb->prefix . "license_key");
        $this->UpdateProductListByTime();
    }

    public function UpdateProductListByTime()
    {
        global $wpdb;
        include_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
        include_once plugin_dir_path(dirname(__FILE__)) . 'core/mantella_import_update_method.php';
        $dium = new DropshipImportUpdateMethod($this->data);

        $record = $wpdb->get_results("select * from " . $wpdb->prefix . "license_key");
        $this->language     = $record[0]->language;
        $this->license_no   = $record[0]->license_no;
        $this->perpage      = $record[0]->perpage;
        $this->total_feed   = $record[0]->total_feed;
        $this->time_var     = $record[0]->time_var;
        $this->import_settings = unserialize($record[0]->import_settings);

        /** prevent problems when time_var is not set or 0 */
        if($record[0]->time_var != 0)
            $this->time_var = $record[0]->time_var*60;
        else
            $this->time_var = 3600;

        /** Get the amount of pages that need to be updated */
        $get_pages_url = $this->api_domain . "feeds/" . $this->domain . "/" . $this->license_no . "/feed/1?perpage=" . $this->perpage ."&time=" . $this->time_var;

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_URL, $get_pages_url);
        $get_pages_result = curl_exec($ch);
        curl_close($ch);
        $pages_data = json_decode($get_pages_result, true);
        $total_pages    = $pages_data['pages'];
        $total_products = $pages_data['products'];

        if($total_products != null)
        {
            /** create a loop for the amount of pages that need to be imported */
            $multiCurl = [];          // multi curl start
            $mh = curl_multi_init();

            $log_status = 'Cron start';
            $record[0]->total_feed = $total_pages;
            $this->logImportedData($log_status, $record,  1, '', '', '', $total_products, 'cronjob_functions');

            for ($i = 1; $i <= $total_pages; $i++)
            {

                /**
                 * Get products
                 */
                $inner_url = $this->api_domain . "feeds/" . $this->domain . "/" . $this->license_no . "/feed/" . $i . "?perpage=" . $this->perpage ."&time=" . $this->time_var;

                //multi curl
                $multiCurl[$i] = curl_init();
                curl_setopt($multiCurl[$i], CURLOPT_URL, $inner_url);
                curl_setopt($multiCurl[$i], CURLOPT_RETURNTRANSFER, 1);
                curl_setopt($multiCurl[$i], CURLOPT_POST, 0);
                curl_setopt($multiCurl[$i], CURLOPT_FOLLOWLOCATION, 1);
                curl_setopt($multiCurl[$i], CURLINFO_HEADER_OUT, true);
                curl_multi_add_handle($mh, $multiCurl[$i]);

            }

            $running = null;

            do {
                curl_multi_exec($mh,$running);
            }
            while($running > 0);
            // close
            curl_multi_close($mh);
            $lang = strtolower($this->language);

            /**
             * Start import/ update
             */

            //get content and remove handles
            foreach($multiCurl as $k => $ch)
            {
                $jsondata = json_decode(curl_multi_getcontent($ch), true);

                if (!empty($jsondata['data']))
                {

                    $k = 0;
                    $b = 0;
                    foreach ($jsondata['data'] as $data)
                    {
                        /** Check if the product is available in the webshop */
                        $this->post_id = $wpdb->get_var("SELECT post_id FROM $wpdb->postmeta WHERE meta_key = '_mantella_ean_number' AND meta_value = '" . $data['ean'] . "'");

                        /** fix for plugin updates from older version */
                        if (empty($this->post_id))
                            $this->post_id = $wpdb->get_var("SELECT post_id FROM $wpdb->postmeta WHERE meta_key = 'post_ean' AND meta_value = '" . $data['ean'] . "'");
                        /** variable check */
                        if (empty($this->post_id))
                            $this->post_id = $wpdb->get_var("SELECT post_id FROM $wpdb->postmeta WHERE meta_key = 'mantella_ean_code' AND meta_value = '" . $data['ean'] . "'");

                        if (!empty($this->post_id))
                        {
                            /**
                             * Check if product sale_price is already set
                             */
                            $response = $dium->update_import_method_from_cron_new($lang, $record, $data, $this->post_id, $b);
                            $b = $response['b'];

                        }
                        unset($jsondata['data'][$k]);
                        $k++;
                    }

                }

                curl_multi_remove_handle($mh, $ch);
            }

            $log_status = 'Cron end';
            $this->logImportedData($log_status, $record,  1, '', '', '', $total_products, 'cronjob_functions');

        }
    }

    //Image Upload function
    public function uploadImagesByTime($post_id, $image_url)
    {
        $image_name = basename($image_url);
        $upload_dir = wp_upload_dir();
        $image_data = @file_get_contents($image_url);
        $unique_file_name = @wp_unique_filename($upload_dir['path'], $image_name);
        $filename = @basename($unique_file_name);

        if (wp_mkdir_p($upload_dir['path']))
        {
            $file = $upload_dir['path'] . '/' . $filename;
        }
        else
        {
            $file = $upload_dir['basedir'] . '/' . $filename;
        }

        file_put_contents($file, $image_data);
        $wp_filetype = wp_check_filetype($filename, null);
        $attachment = array(
            'post_mime_type' => $wp_filetype['type'],
            'post_title' => sanitize_file_name($filename),
            'post_content' => '',
            'post_status' => 'inherit'
        );

        $attach_id = wp_insert_attachment($attachment, $file, $post_id);
        require_once(ABSPATH . 'wp-admin/includes/image.php');
        wp_create_image_subsizes($file, $attach_id);
        unset($image_data);
        unset($attachment);
        unset($attach_data);
        unset($file);
        unset($wp_filetype);
        return $attach_id;
    }

    public function callCronSchedulesUpdateAfterPluginActivate(){

        add_filter('cron_schedules', array($this, 'mantella_custom_cron_schedule_trackupdate_bytime'));

        //Schedule an action if it's not already scheduled
        if (! wp_next_scheduled('mantella_cron_job_trackupdate_bytime'))
        {
            wp_schedule_event(time(), '1hrsupdatecron', 'mantella_cron_job_trackupdate_bytime');
        }

        add_action('mantella_cron_job_trackupdate_bytime', array($this, 'mantella_cron_trackupdate_function_bytime'));
    }

    public function logImportedData($log_status, $record, $pagenumber, $error = '', $imported_arr, $updated_arr, $total_products, $log_type = NULL)
    {
        global $wpdb;

        if ($record != '') {
            if ($pagenumber == 1 && $record[0]->total_feed != 0) {
                $total_batches = $record[0]->total_feed;
            } else {
                $total_batches = 0;
            }
            $total_imported_products = $total_products;
        } else if( $total_products != '')
            $total_imported_products = $total_products;

        if ($error) {
            $this->custom_log($error, 'a', 'debug');
        }

        if ($imported_arr != '') {
            $per_batch_imported = json_encode($imported_arr);
            $message = count($imported_arr) . ' imported';
        } else {
            $per_batch_imported = '';
            $message = '';
        }
        if ($updated_arr != '') {
            $per_batch_updated = json_encode($updated_arr);
            $message = count($updated_arr) . ' updated';
        } else {
            $per_batch_updated = '';
            $message = '';
        }

        if ($imported_arr != '' && $updated_arr != '') {
            $message = count($imported_arr) . ' imported and ' . count($updated_arr) . ' updated';
        }

        if ($message != '') {
            $this->custom_log($message, 'a', 'debug');
        }

        $created_on = date("Y-m-d H:i:s");
        $loggedinuserid = get_current_user_id();

        $logtable = $wpdb->prefix . 'dropship_track_logs';
        $logarr = array(
            'wp_user_id'                => $loggedinuserid,
            'log_text'                  => $error,
            'batch_number'              => $pagenumber,
            'total_batches'             => $total_batches,
            'total_imported_products'   => $total_imported_products,
            'per_batch_imported'        => $per_batch_imported,
            'per_batch_updated'         => $per_batch_updated,
            'log_status'                => $log_status,
            'log_date'                  => $created_on,
            'log_type'                  => $log_type,
            'modified_on'               => $created_on);

        $wpdb->insert($logtable, $logarr);
    }
} 