<?php
if (!defined('ABSPATH')) exit; // Exit if accessed directly

class DropshipOderUpdateTrack
{
    private $plugin_name;
    private $version;
    private $license_no;
    private $domain;
    private $api_domain;
    private $data;

    public function __construct($dataArray)
    {

        $this->plugin_name = $dataArray['plugin_name'];
        $this->version = $dataArray['plugin_version'];
        $this->domain = $dataArray['plugin_domain'];
        $this->api_domain = $dataArray['api_domain'];

        $this->data = $dataArray;

        //method calling
        add_action('wp_ajax_orderdata_save', array($this, 'orderdata_save_function'));
        add_action('wp_ajax_nopriv_orderdata_save', array($this, 'orderdata_save_function'));
        add_action('wp_ajax_update_order_save', array($this, 'update_order_save_function'));
        add_action('wp_ajax_nopriv_update_order_save', array($this, 'update_order_save_function'));

        add_action('wp_ajax_track_order_action', array($this, 'track_order_action_callback'));
        add_action('wp_ajax_nopriv_track_order_action', array($this, 'track_order_action_callback'));
        add_action('init', array($this, 'mntllnl_add_track_order_endpoint'));
        add_filter('query_vars', array($this, 'mntllnl_track_order_query_vars'), 0);
        add_filter('woocommerce_account_menu_items', array($this, 'mntllnl_add_track_order_link_my_account'));
        add_action('woocommerce_account_track_order_endpoint', array($this, 'mntllnl_track_order_content'));
        add_action('init', array($this, 'callMetatBoxAfterValidation'));
    }

    //Dropship Order AJAX Call Start
    public function orderdata_save_function()
    {
        global $wpdb;
        $order = @wc_get_order($_POST['customer_order_id']);
        include_once(ABSPATH . 'wp-admin/includes/upgrade.php');
        $record = $wpdb->get_results("select license_no from " . $wpdb->prefix . "license_key");
        $code = $record[0]->license_no;
        // $reponse = array();
        $orderlines = array();
        $prod_dtl = array();
        $customer_information = $_POST['customer_information'];

        if (!empty($_POST['customer_product_info'])) {
            $count = 0;
            foreach ($_POST['customer_product_info'] as $data) {
                $orderlines[$count] = array(
                    'product_name' => str_replace('\'', '', $data['product_name']),
                    'amount' => $data['quantity'],
                    'ean_no' => $data['ean_no'],
                    'product_id' => $data['product_id'],
                    'price' => $data['price'],
                    'assembly' => 'false',
                );

                $prod_dtl[$count] = array($data['quantity'] . 'X' . str_replace('\'', '', $data['product_name']));
                $prod_data = json_encode($prod_dtl[$count]);
                $count++;
            }

        }

        //uniqe id
        $reference = rand(1, 123456) . time();
        $orderData = array(
            "customer_order_id" => $_POST['customer_order_id'],
            "reference_uniqe_id" => $reference,
            "orderlines" => $orderlines
        );

        $sendOrderData = array(
            "customer_information" => json_encode($customer_information, JSON_HEX_APOS),
            "order_data" => json_encode($orderData, JSON_HEX_APOS),
            "domain" => $this->domain,
            "code" => $code
        );

        $url = $this->api_domain . 'feeds/sendorder/OrderData';
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $sendOrderData);
        $response = curl_exec($ch);
        curl_close($ch);

        if (strpos($response, 'ERROR') !== false) {
            $response = 'error';
        } else {
            $response = json_decode($response, true);
            if (empty($response)) {
                $order_note_error_text = __('Error when sending details:', 'dropship-tool-by-mantella');
                $order_note_text = __('The order response was empty, please contact dropshiptool Support. Do not send the order again.', 'dropship-tool-by-mantella');
                $order_note = $order_note_error_text . ' ' . $order_note_text;
                $order->add_order_note($order_note);
                $data = array('data' => array('reason' => 'The order response was empty, please contact dropshiptool Support. Do not send the order again.'));
            } else {
                if ($response['access'] == 'error') {
                    $order_note_error_text = __('Error when sending details:', 'dropship-tool-by-mantella');
                    $order_note_text = __($response['reason'], 'dropship-tool-by-mantella');
                    $order_note = $order_note_error_text . ' ' . $order_note_text;
                    $order->add_order_note($order_note);
                    $data = array('data' => array('reason' => $response['reason']));
                } else {
                    $orderRespData = $response['data'];
                    $order_data_avail = $wpdb->get_results("SELECT COUNT(id) as tot FROM `" . $wpdb->prefix . "dropship_track_order_dtl` WHERE `woo_order_id`='" . $_POST['customer_order_id'] . "'");
                    if ($order_data_avail[0]->tot > 0) {
                        $customer_id = $_POST['customer_id'];
                        $tablename = $wpdb->prefix . "dropship_track_order_dtl";
                        $status = 'Proccessing';
                        $sql_query = "UPDATE " . $wpdb->prefix . "dropship_track_order_dtl SET `user_id`='" . $customer_id . "',`woo_order_id` = '" . $_POST['customer_order_id'] . "', `ds_order_id` = '" . $orderRespData['order_id'] . "', `status` = '" . $status . "' WHERE `woo_order_id`='" . $_POST['customer_order_id'] . "'";
                        $result_status = $wpdb->query($sql_query);

                        $order_note_success_text = __('Your order details are submitted successfully.', 'dropship-tool-by-mantella');
                        $order_note_problem_text = __('Problem submitting details.', 'dropship-tool-by-mantella');
                        $order_note_text = __($orderRespData['reason'], 'dropship-tool-by-mantella');
                        $order_note = $order_note_success_text . ' ' . ' Now in ' . $status . ' status. <br> Products:' . $prod_data;

                        if ($result_status)
                            $data = array('data' => array('reason' => $order_note_success_text));
                        else
                            $data = array('data' => array('reason' => $order_note_problem_text));

                        $order->add_order_note($order_note);
                    } else {
                        $customer_id = $_POST['customer_id'];
                        $tablename = $wpdb->prefix . "dropship_track_order_dtl";
                        $status = 'Proccessing';
                        $sql_query = "INSERT INTO " . $wpdb->prefix . "dropship_track_order_dtl SET `user_id`='" . $customer_id . "',`woo_order_id` = '" . $_POST['customer_order_id'] . "', `ds_order_id` = '" . $orderRespData['order_id'] . "',`ds_order_data` = '" . json_encode($orderRespData, JSON_HEX_APOS) . "', `status` = '" . $status . "' ";
                        $result_status = $wpdb->query($sql_query);
                        $order_note_success_text = __('Your order details are submitted successfully.', 'dropship-tool-by-mantella');
                        $order_note_problem_text = __('Problem submitting details.', 'dropship-tool-by-mantella');
                        $order_note_text = __($response['reason'], 'dropship-tool-by-mantella');
                        $order_note = $order_note_success_text . ' ' . ' Now in ' . $status . ' status. <br> Products:' . $prod_data;

                        if ($result_status)
                            $data = array('data' => array('reason' => $order_note_success_text));
                        else
                            $data = array('data' => array('reason' => $order_note_problem_text));

                        $order->add_order_note($order_note);
                    }

                }

            }

        }

        echo json_encode($data, JSON_HEX_APOS);
        exit();
    }

    //Dropship Order AJAX Call Ends
    //Start
    public function update_order_save_function()
    {
        global $wpdb;
        $record = $wpdb->get_results("select license_no from " . $wpdb->prefix . "license_key");
        $license_no = $record[0]->license_no;
        $recordOrder = $wpdb->get_results("select * from " . $wpdb->prefix . "dropship_track_order_dtl WHERE woo_order_id='" . $_POST['customer_order_id'] . "' ");
        $ds_order_id = $recordOrder[0]->ds_order_id;
        $url = $this->api_domain . "feeds/" . $this->domain . "/" . $license_no . "/trackingcodes/" . $_POST['customer_order_id'];

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_URL, $url);
        $result = curl_exec($ch);
        $err = curl_error($ch);
        curl_close($ch);
        $response = json_decode($result, true);
        //$orderData = $response['data'];
        $orderData = [];
        if (is_array($response['data'])) {
            foreach ($response['data'] as $resdata) {
                array_push($orderData, $resdata['tracking_code']);
            }
        }

        if ($err) {
            $resp = 'error';
        } else {
            $tracking_codes = '';
            if (is_array($response['data'])) {
                $tracking_codes = json_encode($orderData, JSON_HEX_APOS);
            }
            $sql_query = "UPDATE " . $wpdb->prefix . "dropship_track_order_dtl SET `tracking_status_ds` = '1', `tracking_codes` = '" . $tracking_codes . "' WHERE `woo_order_id`='" . $_POST['customer_order_id'] . "'";
            $result_status = $wpdb->query($sql_query);
            if ($result_status) {
                $resp = 'success';
            } else {
                $resp = 'error';
            }
        }

        echo json_encode($resp, JSON_HEX_APOS);
        exit();
    }
    //Ends

    // Add meta box
    public function mds_tracking_box()
    {
        add_meta_box(
            'mds-tracking-modal',
            'Dropship Order', array($this, 'mds_meta_box_callback'),
            'shop_order',
            'side',
            'core'
        );
    }

    // Callback function
    public function mds_meta_box_callback($post)
    {
        global $wpdb;
        $order = wc_get_order($post->ID);
        $order_data_avail = $wpdb->get_results("SELECT COUNT(id) as tot, ds_order_id, tracking_codes, tracking_status_ds, status FROM `" . $wpdb->prefix . "dropship_track_order_dtl` WHERE `woo_order_id`='" . $order->get_id() . "'");

        //$value = get_post_meta( $post->ID, '_tracking_box', true );
        $send_to_twm_text = __('Send order to TWM', 'dropship-tool-by-mantella');
        $Get_Update_Your_Order_Text = __('Update Track & Trace information', 'dropship-tool-by-mantella');
        $Order_has_been_send_text = __('Order has been send', 'dropship-tool-by-mantella');
        $Parcel_has_been_text = __('Parcel has been', 'dropship-tool-by-mantella');

        //$order_data_avail[0]->tot =1;

        echo '<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css" crossorigin="anonymous">
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.4/css/all.min.css" integrity="sha512-1ycn6IcaQQ40/MKBW2W4Rhis/DbILU74C1vSrLJxCq57o941Ym01SwNsOMqvEBFlcgUa6xLiPY/NS5R+E6ztJQ==" crossorigin="anonymous" referrerpolicy="no-referrer" />
        <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" crossorigin="anonymous"></script>
        <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js" crossorigin="anonymous"></script>';
        if ($order_data_avail[0]->tot > 0) {
            echo '<button id="send_order_to_supplier1" type="button" class="button button-primary" style="background:green; border:green solid 1px;" data-toggle="modal" data-target="#send_order_to_supplier1_BTN"> <i class="fas fa-shipping-fast"></i> ' . __('Order has been send', 'dropship-tool-by-mantella') . ' </button>';
            echo '<br><br>';
        } else {
            echo '<button id="send_order_to_supplier" type="button" class="button button-primary" data-toggle="modal" data-target="#send_order_to_supplier_BTN"><i class="fas fa-shipping-fast"></i> ' . __('Send order to TWM', 'dropship-tool-by-mantella') . ' </button>';
            echo '<br><br>';
        }

        if ($order_data_avail[0]->tot == 0) {
            echo '<button id="get_track_and_trace_update" type="button" class="button button-primary" data-toggle="modal" data-target="#get_track_and_trace_updateBTN"> <i class="fas fa-box-open"></i> ' . __('Update Track & Trace information', 'dropship-tool-by-mantella') . '</button>';
        } else {
            echo '<button id="get_track_and_trace_update1" type="button" class="button button-primary" style="background:green; border:green solid 1px;" data-toggle="modal" data-target="#get_track_and_trace_update_Popup1"> <i class="fas fa-box-open"></i> ' . __('Parcel has been', 'dropship-tool-by-mantella') . ' ' . $order_data_avail[0]->status . '</button>';
        }

        echo '<br><br><br>';
        foreach ($order_data_avail as $rec) {
            $track_data = json_decode($rec->tracking_codes, TRUE);
            $i = 1;
            foreach ($track_data as $key => $td) {
                echo 'Tracking Code : <span style="cursor: pointer; color:#0085ba;" class="track_data_cls" id="' . $order->get_id() . '_' . $i . '">' . $td['tracking_code'] . '</span><br>';
                echo 'Tracking Status : ' . $td['status'] . '<br>';
                echo '<br>';
                $i++;
            }
        }

        $order = wc_get_order($post->ID);
        $currency_symbol = get_woocommerce_currency_symbol($order->get_currency());
        // Get Order Items
        $items = $order->get_items();
        //Order Details Ends//
        $send_order_to_supplier_text = __('Send order to supplier', 'dropship-tool-by-mantella');

        echo '<div class="modal fade" id="send_order_to_supplier_BTN" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
                  <div class="modal-dialog">
                        <div class="modal-content">
                              <div class="modal-header">
                                    <h5 class="modal-title" id="exampleModalLabel">' . $send_order_to_supplier_text . '</h5>
                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                      <span aria-hidden="true">&times;</span>
                                    </button>
                              </div>
                              <div class="modal-body">'; ?>

        <div id="before_success_resp">
            <?php
            $count = 0;

            foreach ($items as $item_id => $item_data) {
                //Check if variation product
                if (isset($item_data['variation_id']) && $item_data['variation_id'] != 0) {
                    $product_id = $item_data['variation_id'];
                    $ean_no = get_post_meta($product_id, "mantella_ean_code", true);
                } else {
                    $product_id = $item_data["product_id"];
                    $ean_no = get_post_meta($product_id, "_mantella_ean_number", true);
                }

                $item_data['name'] = str_replace("'", "", $item_data['name']);

                echo '<div class="checkbox"><label><input type="checkbox" name="product_ids[]" value="' . $product_id . '"><strong> ' . $item_data['name'] . '</strong></label></div>';

                //Create array
                $product_info = array(
                    'product_sr_id' => $item_id,
                    'product_id' => $product_id,
                    'ean_no' => $ean_no,
                    'product_name' => $item_data['name'],
                    'quantity' => $order->get_item_meta($item_id, '_qty', true),
                    'product_sku' => $order->get_item_meta($item_id, 'sku', true),
                    'price' => $currency_symbol . $order->get_item_meta($item_id, '_line_total', true)
                );

                if (!empty($order->get_formatted_shipping_address())) {
                    $customer_info = array(
                        'customer_first_name' => $order->get_shipping_first_name(),
                        'customer_last_name' => $order->get_shipping_last_name(),
                        'customer_company' => $order->get_shipping_company(),
                        'customer_address_1' => $order->get_shipping_address_1(),
                        'customer_address_2' => $order->get_shipping_address_2(),
                        'customer_city' => $order->get_shipping_city(),
                        'customer_state' => $order->get_shipping_state(),
                        'customer_postcode' => $order->get_shipping_postcode(),
                        'customer_country' => $order->get_shipping_country(),
                        'customer_address' => $order->get_address(),
                        'customer_email' => $order->get_billing_email(),
                        'customer_phonenumber' => $order->get_billing_phone()
                    );
                } else {
                    $customer_info = array(
                        'customer_first_name' => $order->get_billing_first_name(),
                        'customer_last_name' => $order->get_billing_last_name(),
                        'customer_company' => $order->get_billing_company(),
                        'customer_address_1' => $order->get_billing_address_1(),
                        'customer_address_2' => $order->get_billing_address_2(),
                        'customer_city' => $order->get_billing_city(),
                        'customer_state' => $order->get_billing_state(),
                        'customer_postcode' => $order->get_billing_postcode(),
                        'customer_country' => $order->get_billing_country(),
                        'customer_address' => $order->get_address(),
                        'customer_email' => $order->get_billing_email(),
                        'customer_phonenumber' => $order->get_billing_phone()
                    );
                }

                $customer_info_json = json_encode($customer_info, JSON_HEX_APOS);
                $product_info_json = json_encode($product_info, JSON_HEX_APOS);
                $count++;
                ?>
                <input type="hidden" name="customer_product_info[]"
                       id="customer_product_info_<?php echo $product_id; ?>" value='<?php echo $product_info_json; ?>'>
                <?php
            }
            $send_btn_text = __('Send to Supplier', 'dropship-tool-by-mantella');
            ?>
            <input type="hidden" name="customer_id" id="customer_id" value='<?php echo $order->get_customer_id(); ?>'>
            <input type="hidden" name="customer_information" id="customer_information"
                   value='<?php echo $customer_info_json; ?>'>
            <input type="hidden" name="customer_order_id" id="customer_order_id"
                   value='<?php echo $order->get_id(); ?>'>
        </div>
        <div id="success_resp"></div>

        <?php
        echo '</div>
                                  <div class="modal-footer">
                                        <button type="button" class="btn btn-primary" id="send_order_to_supplier_button">' . $send_btn_text . '</button>
                                  </div>
                        </div>
                  </div>
            </div>';

        $order_message = __('Order is already placed.', 'dropship-tool-by-mantella');
        echo '<div class="modal fade" id="send_order_to_supplier1_BTN" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
              <div class="modal-dialog">
                    <div class="modal-content">
                          <div class="modal-header">
                                <h5 class="modal-title">' . $send_order_to_supplier_text . '</h5>
                                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                  <span aria-hidden="true">&times;</span>
                                </button>
                          </div>
                          <div class="modal-body">
                           ' . $order_message . '
                          </div>
                    </div>
              </div>
         </div>';

        $track_code_message = __('There is no track & trace available. Please try again later', 'dropship-tool-by-mantella');
        $track_code_text = __('Tracking Code', 'dropship-tool-by-mantella');
        $track_status_text = __('Tracking Status', 'dropship-tool-by-mantella');

        echo '<div class="modal fade" id="get_track_and_trace_update_Popup1" tabindex="-1" aria-labelledby="exampleModalLabel6" aria-hidden="true">
              <div class="modal-dialog">
                    <div class="modal-content">
                          <div class="modal-header">
                                <h5 class="modal-title" id="exampleModalLabel6">' . __('Parcel Details', 'dropship-tool-by-mantella') . '</h5>
                                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                  <span aria-hidden="true">&times;</span>
                                </button>
                          </div>
                          <div class="modal-body">';
        if (empty($order_data_avail[0]->tracking_codes)) {
            echo '<h6>' . $track_code_message . '</h6>';
        } else {
            foreach ($order_data_avail as $rec) {
                $track_data = json_decode($rec->tracking_codes, TRUE);
                $i = 1;
                foreach ($track_data as $key => $td) {
                    echo $track_code_text . ' : <span style="cursor: pointer; color:#0085ba;" class="track_data_cls" id="' . $order->get_id() . '_' . $i . '">' . $td['tracking_code'] . '</span><br>';
                    echo $track_status_text . ' : ' . $td['status'] . '<br>';
                    echo '<br>';
                    $i++;
                }
            }
        }
        echo '</div>
                    </div>
              </div>
        </div>';

        $get_track_update_text = __('Get Track & Trace Update', 'dropship-tool-by-mantella');
        $update_message_text = __('Order Updated Successfully.', 'dropship-tool-by-mantella');
        $updateOrderStatus = __('Update Order Status', 'dropship-tool-by-mantella');

        echo '<div class="modal fade" id="get_track_and_trace_updateBTN" tabindex="-1" aria-labelledby="exampleModalLabel5" aria-hidden="true">
              <div class="modal-dialog">
                    <div class="modal-content">
                          <div class="modal-header">
                                <h5 class="modal-title" id="exampleModalLabel5">' . $get_track_update_text . '</h5>
                                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                  <span aria-hidden="true">&times;</span>
                                </button>
                          </div>
                          <div class="modal-body">
                                <div id="before_success_respOrder">';

        foreach ($items as $item_id => $item_data) {
            echo '<br> EAN No: ' . get_post_meta($item_data['product_id'], "_mantella_ean_number", true);
            echo '<br> Product: ' . $item_data['name'];
            echo '<br> Quantity: ' . $order->get_item_meta($item_id, '_qty', true);
            echo '<br> Price: ' . $currency_symbol . $order->get_item_meta($item_id, '_line_total', true);
            echo '<br>';
        }
        echo '<br/><input type="hidden" name="update_order_id" id="update_order_id" value=' . $order->get_id() . '>';
        echo '</div>
                                <div id="success_respOrder">' . $update_message_text . '</div></div>
                          <div class="modal-footer">
                                <button type="button" class="btn btn-primary" id="update_order_details">' . $updateOrderStatus . '</button>
                          </div>
                    </div>
              </div>
        </div>';

        foreach ($order_data_avail as $rec) {
            $track_data = json_decode($rec->tracking_codes, TRUE);
            $j = 1;
            foreach ($track_data as $key => $td) {
                echo '<div id="trace_update_Popup' . $order->get_id() . '_' . $j . '" class="modal fade" role="dialog">
                <div class="modal-dialog">
                    <div class="modal-content">
                          <div class="modal-header">
                                <h5 class="modal-title" id="exampleModalLabel5">' . __('Get Track & Trace Update', 'dropship-tool-by-mantella') . '</h5>
                                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                  <span aria-hidden="true">&times;</span>
                                </button>
                          </div>
                          <div class="modal-body">
                                <form>
                                Tracking Code : ' . $td['tracking_code'] . '<br>
                                Tracking Status : ' . $td['status'] . '<br>
                                </form>
                          </div>
                          <div class="modal-footer">
                                <button type="button" class="btn btn-danger btn-secondary" data-dismiss="modal">' . __('Close', 'dropship-tool-by-mantella') . '</button>
                          </div>
                    </div>
                </div>
		</div>';
                $j++;
            }
        }
        ?>
        <script type="text/javascript">
            jQuery(function () {
                jQuery("#success_respOrder").css('display', 'none');
                jQuery('.track_data_cls').click(function () {
                    var id = jQuery(this).prop('id');
                    jQuery("#trace_update_Popup" + id + "").modal("show");
                });

                jQuery("#send_order_to_supplier_button").click(function () {
                    var order_data = new Array();
                    var customer_product_info = new Array();
                    jQuery('input:checkbox[name="product_ids[]"]:checked').each(function () {
                        order_data.push(jQuery(this).val());
                        pid = jQuery(this).val();
                        customer_product_info.push(JSON.parse(jQuery("#customer_product_info_" + pid).val()));
                    });

                    order_data = Object.assign({}, order_data);
                    order_data = JSON.stringify(order_data);
                    var ajaxurl = "<?php echo admin_url('admin-ajax.php'); ?>";
                    var customer_id = jQuery("#customer_id").val();
                    var customer_information = jQuery("#customer_information").val();
                    var customer_order_id = jQuery("#customer_order_id").val();
                    var data = {
                        "action": "orderdata_save",
                        "order_data": JSON.parse(order_data),
                        "customer_id": JSON.parse(customer_id),
                        "customer_information": JSON.parse(customer_information),
                        "customer_order_id": JSON.parse(customer_order_id),
                        "customer_product_info": customer_product_info
                    };

                    if (customer_product_info.length > 0) {
                        jQuery.ajax({
                            type: "POST",
                            url: ajaxurl,
                            data: data,
                            success: function (resp) {
                                var respdata = JSON.parse(resp);
                                jQuery("#success_resp").text(respdata.data.reason);
                                jQuery("#before_success_resp").css("display", "none");
                                console.log(resp);
                            },
                            error: function (errorThrown) {
                                console.log(errorThrown);
                            }
                        });
                    } else {
                        alert('Please select product for send order to supplier.');
                        console.log('order_data is empty.');
                        return false;
                    }
                    return false;
                });

                //Order details status updates
                jQuery("#update_order_details").click(function () {
                    var ajaxurl = "<?php echo admin_url('admin-ajax.php'); ?>";
                    var update_order_id = jQuery("#update_order_id").val();
                    var data = {
                        "action": "update_order_save",
                        "customer_order_id": JSON.parse(update_order_id)
                    };

                    jQuery.ajax({
                        type: "POST",
                        url: ajaxurl,
                        data: data,
                        success: function (resp) {
                            jQuery("#success_respOrder").css('display', 'block');
                            jQuery("#success_respOrder").text(resp);
                            jQuery("#before_success_respOrder").css("display", "none");
                            console.log(resp);
                        },
                        error: function (errorThrown) {
                            console.log(errorThrown);
                        }
                    });
                });

                jQuery("#send_order_to_supplier").click(function () {
                    jQuery("#send_order_to_supplier_Popup").modal({
                        backdrop: 'static',
                        keyboard: false,
                        show: true
                    });
                });

                jQuery("#send_order_to_supplier1").click(function () {
                    jQuery("#send_order_to_supplier_Popup1").modal({
                        backdrop: 'static',
                        keyboard: false,
                        show: true
                    });
                });

                jQuery("#send_order_to_supplier_Close").click(function () {
                    jQuery('#send_order_to_supplier_Popup').modal('hide');
                    location.reload();
                });

                jQuery("#get_track_and_trace_update1").click(function () {
                    jQuery("#get_track_and_trace_update_Popup1").modal({
                        backdrop: 'static',
                        keyboard: false,
                        show: true
                    });
                });

                jQuery("#get_track_and_trace_update").click(function () {
                    jQuery("#get_track_and_trace_update_Popup").modal({
                        backdrop: 'static',
                        keyboard: false,
                        show: true
                    });
                });

                jQuery("#get_track_and_trace_update_Close").click(function () {
                    jQuery('#get_track_and_trace_update_Popup').modal('hide');
                    location.reload();
                });
            });
        </script>
        <?php
    }
    //Dropship Order Ends

    //Testing Starts
    public function track_order_action_callback()
    {
        global $wpdb;
        $order_number = $_POST['order_number'];
        $order_data_avail = $wpdb->get_results("SELECT COUNT(id) as tot, ds_order_id, tracking_codes, tracking_status_ds, status FROM `" . $wpdb->prefix . "dropship_track_order_dtl` WHERE `woo_order_id`='" . $order_number . "'");

        if ($order_data_avail[0]->tot > 0) {
            if (empty($order_data_avail[0]->tracking_codes)) {
                //
                $status = '';
                $tracking_code = '';
                $error_message_text = __('There is no track&trace available. Please try again later. ', 'dropship-tool-by-mantella');
                $resp = array('data' => array('error_status' => "0", 'tracking_code_status' => $error_message_text, 'tracking_code' => $tracking_code, 'status' => $status));
            } else {
                foreach ($order_data_avail as $rec) {
                    $track_data = json_decode($rec->tracking_codes, TRUE);
                    //$k = 1;
                    foreach ($track_data as $key => $td) {
                        $tracking_code = !empty($td['tracking_code']) ? $td['tracking_code'] : ' ';
                        $status = !empty($td['status']) ? $td['status'] : ' ';
                        $resp = array('data' => array('error_status' => "0", 'tracking_code' => $tracking_code, 'status' => $status));
                    }
                }
            }

        } else {
            $error_message_text = __('The order is not available. Please refresh and try again later.', 'dropship-tool-by-mantella');
            $resp = array('data' => array('error_status' => "1", 'error' => $error_message_text));
        }
        echo json_encode($resp, JSON_HEX_APOS);
        exit();
    }

    public function mntllnl_add_track_order_endpoint()
    {
        add_rewrite_endpoint('track_order', EP_ROOT | EP_PAGES | EP_PERMALINK);
        flush_rewrite_rules(false);
    }

    //Add new query var
    public function mntllnl_track_order_query_vars($vars)
    {
        $vars[] = 'track_order';
        //$vars[] = 'track_order_endpoint';
        return $vars;
    }

    //Insert the new endpoint into the My Account menu
    public function mntllnl_add_track_order_link_my_account($items)
    {
        $items['track_order'] = __('Track Order', 'dropship-tool-by-mantella');
        return $items;
    }

    //Add content to the new endpoint
    public function mntllnl_track_order_content()
    {
        ?>
        <h5><?php echo __('Track Your Order Status', 'dropship-tool-by-mantella'); ?></h5>
        <div id="my_order_status_dtl"></div>
        <form id="mydataform">
            <input type="text" name="my_order_number" id="my_order_number"
                   placeholder="<?php echo __('Enter your order number', 'dropship-tool-by-mantella'); ?>" value="">
            <input type="button" name="order_status" id="submitMyFormData"
                   value="<?php echo __('Check Status', 'dropship-tool-by-mantella'); ?>">
        </form>
        <script>
            jQuery(document).ready(function ($) {
                jQuery("#submitMyFormData").click(function () {
                    var order_number = jQuery("#my_order_number").val();
                    var ajaxurl = "<?php echo admin_url('admin-ajax.php'); ?>";

                    jQuery.ajax({
                        type: "post",
                        dataType: "json",
                        url: ajaxurl,
                        data: {
                            "action": "track_order_action",
                            "order_number": order_number
                        },
                        success: function (resp) {
                            var respdatas = JSON.parse(JSON.stringify(resp));
                            alert(respdatas);
                            if (respdatas.data.error_status == 1) {
                                jQuery("#my_order_status_dtl").html('<div style="color:red;">' + respdatas.data.error + '</div>');
                            } else {
                                if (respdatas.data.tracking_code_status !== "") {
                                    jQuery("#my_order_status_dtl").html('<div style="color:red;">' + respdatas.data.tracking_code_status + '</div>');
                                } else {
                                    jQuery("#my_order_status_dtl").html('<div style="color:green;">Tracking Code : ' + respdatas.data.tracking_code + '<br> Tracking Status : ' + respdatas.data.status + '</div>');
                                }
                            }
                            console.log(resp);
                        },
                        error: function (errorThrown) {
                            console.log(errorThrown);
                        }
                    });
                });
            });
        </script>
        <?php
        // echo do_shortcode('');
    }

    //validating license key before showing order track button
    public function callMetatBoxAfterValidation()
    {
        global $wpdb;
        $this->record = $wpdb->get_results("SELECT * FROM " . $wpdb->prefix . "license_key");
        if (isset($this->record[0]->license_status) && $this->record[0]->license_status == 'The license key is valid and active') {
            add_action('add_meta_boxes', array($this, 'mds_tracking_box'));
        }
    }

}

?>
