<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class DropshipSendtoPortal
{
    private $plugin_name;
    private $version;
    private $license_no;
    private $domain;
    private $api_domain;
    private $data;

    public function __construct($dataArray)
    {
        $this->plugin_name  = $dataArray['plugin_name'];
        $this->version      = $dataArray['plugin_version'];
        $this->domain       = $dataArray['plugin_domain'];
        $this->api_domain   = $dataArray['api_domain'];
        $this->data         = $dataArray;
    }

    public function sendtoAPI()
    {
        global $wpdb, $woocommerce, $wp_version;
        include_once( ABSPATH . 'wp-admin/includes/upgrade.php' );

        $record = $wpdb->get_results("select * from " . $wpdb->prefix . "license_key");
        $this->license_no                           = $record[0]->license_no;
        $import_settings                            = unserialize($record[0]->import_settings);
        $import_settings['language']                = $record[0]->language;
        $import_settings['license_status']          = $record[0]->license_status;
        $import_settings['total_feed']              = $record[0]->total_feed;
        $import_settings['time_var']                = $record[0]->time_var;
        $import_settings['ean_show_in_front']       = $record[0]->ean_show_in_front;
        $import_settings['brand_show_in_front']     = $record[0]->brand_show_in_front;
        $import_settings['brand_with_title_status'] = $record[0]->brand_with_title_status;

        $shop_domain            = get_home_url();
        $plugin_version         = $this->version;
        $wordpress_version      = $wp_version;
        $woocommerce_version    = $woocommerce->version;
        $php_version            = phpversion();
        $theme_name             = get_current_theme();

        $website_details = array(
            'domain'                => $this->domain,
            'licensekey'            => $this->license_no,
            'shop_domain'           => $shop_domain,
            'plugin_version'        => $plugin_version,
            'wordpress_version'     => $wordpress_version,
            'woocommerce_version'   => $woocommerce_version,
            'php_version'           => $php_version,
            'theme_name'            => $theme_name,
            'plugin_name'           => $this->plugin_name,
            'import_settings'       => json_encode($import_settings),
        );

        $url = $this->api_domain . '/feeds/sendshopinfo/site_details_to_api';

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);        //
        curl_setopt($ch, CURLOPT_POSTFIELDS, $website_details);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        $response = curl_exec($ch);
        curl_close($ch);
        $response = json_decode($response, true);
        return ($response);
    }
    public function sendErrorEmail()
    {
        $to = 'info@dropshiptool.eu';
        $subject = 'Error in import process';
        $body = 'There is no error in import process.';
        if (file_exists(WP_CONTENT_DIR . '/uploads/import_log/debug.log')) {
            $body = 'There is an error in import process. please check attachement';
        }
        //$headers = array('Content-Type: text/html; charset=UTF-8'); //if text is plain
        $adminemail = get_option( 'admin_email' );
        $attachments = array( WP_CONTENT_DIR . '/uploads/import_log/debug.log' );
        $headers = 'From: Error Email <'.$adminemail.'>' . "\r\n";

        wp_mail( $to, $subject, $body, $headers, $attachments );

        //wp_mail( $to, $subject, $body, $headers );
        return ('mail sent');
    }

} 
