<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class DropshipProductStock
{
    private $plugin_name;
    private $version;
    private $domain;
    private $api_domain;

    public function __construct($dataArray)
    {
        $this->plugin_name = $dataArray['plugin_name'];
        $this->version = $dataArray['plugin_version'];
        $this->domain = $dataArray['plugin_domain'];
        $this->api_domain = $dataArray['api_domain'];
        //add_filter('cron_schedules', array($this, 'mantella_update_cron_schedule'));
    }

    public function product_stock($license_no, $domain)
    {
        global $wpdb;

        $args = array(
            'post_type' => 'product',
            'posts_per_page' => -1
        );

        $loop = new WP_Query($args);
        $i = 0;
        if ($loop->have_posts()): while ($loop->have_posts()): $loop->the_post();
            global $product;

            $key_1_values = get_post_meta($product->get_id(), '_mantella_ean_number');

            /** Additional for support to older version updates */
            if (!$key_1_values[0])
                $key_1_values = get_post_meta($product->get_id(), 'post_ean');

            if (!$key_1_values[0])
                $key_1_values = get_post_meta($product->get_id(), 'mantella_ean_code');

            if ($key_1_values[0])
            {
                $post_id = $product->get_id();
                $url = $this->api_domain . "feeds/" . $domain . "/" . $license_no . "/stock/" . $key_1_values[0];
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                curl_setopt($ch, CURLOPT_URL, $url);
                $result = curl_exec($ch);
                $json = json_decode($result, true);

                if ($json == NULL)
                {
                    $error_status = 1;
                }
                else
                {
                    $error_status = 0;
                    if ($json['product_ean'] == $key_1_values[0])
                    {
                        update_post_meta($post_id, '_stock', $json['stock']);
                        update_post_meta($post_id, '_regular_price', $json['consumer_price']);
                        update_post_meta($post_id, '_price', $json['consumer_price']);

                        if ($json['stock'] < 1) {
                            update_post_meta($post_id, '_stock_status', 'outofstock');

                            $table_attr_lookup   = $wpdb->prefix . 'wc_product_attributes_lookup';
                            $update_stock_lookup = $wpdb->update( $table_attr_lookup, array( 'in_stock' => 0 ), array( 'product_id' =>  $post_id) );
                        }
                        else{
                            update_post_meta($post_id, '_stock_status', 'instock');

                            $table_attr_lookup   = $wpdb->prefix . 'wc_product_attributes_lookup';
                            $update_stock_lookup = $wpdb->update( $table_attr_lookup, array( 'in_stock' => 1 ), array( 'product_id' =>  $post_id) );
                        }

                        wc_delete_product_transients($post_id);
                        $i++;
                    }
                }
            }
        endwhile;
        endif;
        wp_reset_postdata();
        if ($error_status == 1)
        {
            $msg = "<div class='alert alert-danger' role='alert'>
					<strong>Problem getting response!</strong> Please contact dropshiptool Support.
				</div>";
            $_SESSION['PROMSG'] = $msg;
        }
        else
        {
            $msg = "<div class='alert alert-success' role='alert'>
				  <strong>Success!</strong> Product stock and price have been updated for " . $i . " products
				</div>";
            $_SESSION['PROMSG'] = $msg;
        }
 
    }
 
}
