<?php
/**
 * @package     Dropshiptool
 * @version     3.0.0
 * @copyright   2023 Dropshiptool
**/

/*
  Plugin Name:          Dropshiptool
  Plugin URI:           https://dropshiptool.eu
  Depends:              WooCommerce
  Description:          Dropshiptool. Import and update dropship products into your webshop. We support Meeples (www.meeplesdistributie.nl) and TOM BV (www.twm-bv.com)
  Version:              3.0.0
  Requires at least:    5.6
  Requires PHP:         7.4
  Author:               Dropshiptool
  Author URI:           https://dropshiptool.eu
  Text Domain:          dropshiptool
  Domain Path:          /languages
  License:              GPL2
  License URI:          https://dropshiptool.eu
*/

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) )
{
    die('Direct access not allowed');
}
//set the php ini value
define( 'MAX_EXECUTION_TIME_LIMIT', ini_get("max_execution_time") );

//Load language details
function load_plugin_textdomain_lang()
{
	$textdomain = 'dropship-tool-by-mantella';
	$mo_file = dirname( __FILE__ ) . '/languages/'. $textdomain .'-' .get_locale(). '.mo';
	load_textdomain( $textdomain, $mo_file );
}

add_action( 'plugins_loaded', 'load_plugin_textdomain_lang' );

define( 'DROPSHIP_TOOL_BY_MANTELLA_VERSION', '3.0.0' ); //setting plugin version
define( 'PLUGIN_DIR_URL', plugin_dir_url( __FILE__ ) ); //setting path of plugin

ini_set('error_reporting', 0);
ini_set('display_errors', 0);
ini_set('log_errors', 0);

//Adding settings links
function mantella_plugin_action_links($links, $file) {
    static $this_plugin;
    if (!$this_plugin) {
        $this_plugin = plugin_basename(__FILE__);
    }
    if ($file == $this_plugin) {
        $settings_link = '<a href="' . get_bloginfo('wpurl') . '/wp-admin/admin.php?page=mantella">'. __('Settings', 'dropship-tool-by-mantella') .'</a>';
        array_unshift($links, $settings_link);
    }
    return $links;
}

add_filter('plugin_action_links', 'mantella_plugin_action_links', 10, 2);


function activate_dropship_tool_by_mantella()
{
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-dropship-tool-by-mantella-activator.php';
	Dropship_Tool_By_Mantella_Activator::activate();
}

register_activation_hook( __FILE__, 'activate_dropship_tool_by_mantella' );


function deactivate_dropship_tool_by_mantella()
{
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-dropship-tool-by-mantella-deactivator.php';
	Dropship_Tool_By_Mantella_Deactivator::deactivate();
}

register_deactivation_hook( __FILE__, 'deactivate_dropship_tool_by_mantella' );

require plugin_dir_path( __FILE__ ) . 'includes/class-dropship-tool-by-mantella.php';
function run_dropship_tool_by_mantella()
{
	$plugin = new Dropship_Tool_By_Mantella();
	$plugin->run();
}
run_dropship_tool_by_mantella();