<?php
if (! defined('ABSPATH')) exit;// Exit if accessed directly

//Temaplate class
class DropshipTemplate
{
    private $plugin_name;
    private $version;
    private $language;
    private $license_no;
    private $domain;
    private $api_domain;
    private $data;

    public function __construct($dataArray)
    {
        $this->plugin_name  = $dataArray['plugin_name'];
        $this->version      = $dataArray['plugin_version'];
        $this->domain       = $dataArray['plugin_domain'];
        $this->api_domain   = $dataArray['api_domain'];
        $this->data         = $dataArray;

        //calling menu
        add_action('admin_menu', array($this,'mantell_plugin_setup_menu'));
        add_action('admin_head', array($this,'icon_admin_menu_mantella'));

        add_action('wp_ajax_send_data_action', array($this,'sendinfotomantella'));
        add_action('wp_ajax_nopriv_send_data_action', array($this,'sendinfotomantella'));

        add_action('wp_ajax_delete_eans', array($this,'deleteEans'));
        add_action('wp_ajax_delete_attr', array($this,'deleteAttr'));
        add_action('wp_ajax_delete_all_eans', array($this,'deleteAllEans'));

        add_action('wp_ajax_check_import_status', array($this,'checkImportStatus'));
        add_action('wp_ajax_nopriv_check_import_status', array($this,'checkImportStatus'));
      
        add_action('wp_ajax_get_imported_products_status', array($this,'getImportedProductsStatus'));
        add_action('wp_ajax_nopriv_get_imported_products_status', array($this,'getImportedProductsStatus'));

        //send error mail to mantella
        add_action('wp_ajax_send_error_to_mantella', array($this,'senderrortomantella'));
        add_action('wp_ajax_nopriv_send_error_to_mantella', array($this,'senderrortomantella'));
    }

    // Adding Menu to Plugin
    public function mantell_plugin_setup_menu()
    {
        add_menu_page('Dropship Tool', 'Dropship Tool', 'manage_woocommerce', 'mantella', array($this, 'dropship_platform'), 'div');
    }

    //Adding Menu image and style
    public function icon_admin_menu_mantella()
    {
        $this->hover_icon = plugin_dir_url( __FILE__ ) . 'assets/mantella_icon-hover.png';
        $this->icon = plugin_dir_url( __FILE__ ) . 'assets/mantella_icon.png';
        echo '<style type="text/css">
	    #adminmenu #toplevel_page_mantella div.wp-menu-image {
            background:url('. $this->icon .') no-repeat;
            background-position:center center;
            background-size: 50%;
        }
		
		#adminmenu #toplevel_page_mantella:hover div.wp-menu-image{
            background:url('. $this->hover_icon . ') no-repeat;
            background-position:center center;
            background-size: 50%;
	    }
		
		.form-group.row {
            margin-right: 0px;
            margin-left: 0px;
        }
		
		.form-group.row .col-sm-12 {
			padding-left: 0px;
			
		}
		
		.form-valid  {
			opacity:0.5;
		}
		
		.form-control-label abbr {
			text-decoration: none;
			font-weight: normal;
		}
		
		.clserror{
		    display: none;
		}
		
		.form-control.is-valid, .was-validated .form-control:valid {
            border-color: #23282d;
            padding-right: calc(1.5em + .75rem);
            background-image: none !important;
            background-repeat: no-repeat;
            background-position: right calc(.375em + .1875rem) center;
            background-size: calc(.75em + .375rem) calc(.75em + .375rem);
        }
        
        .form-control.is-invalid, .was-validated .form-control:invalid {
            border-color: #dc3545;
            padding-right: calc(1.5em + .75rem);
            background-image: none !important;
            background-repeat: no-repeat;
            background-position: right calc(.375em + .1875rem) center;
            background-size: calc(.75em + .375rem) calc(.75em + .375rem);
        } 
        
        .form-check-input.is-valid~.form-check-label, .was-validated .form-check-input:valid~.form-check-label {
            color: #23282d !important; 
        }
                
        .form-check-input.is-invalid~.form-check-label, .was-validated .form-check-input:invalid~.form-check-label {
            color: #dc3545;
        }
        
        .row {
            display: flex;
            flex-wrap: wrap;
            margin: 0 -15px
        }
        .row>div {
            padding-left: 15px;
            padding-right: 15px
        }
        .col1 {
            width: 8.33%
        }
        .col2 {
            width: 16.66%
        }
        .col3 {
            width: 25%
        }
        .col4 {
            width: 33.33%
        }
        .col5 {
            width: 41.66%
        }
        .col6 {
            width: 50%
        }
        .col7 {
            width: 58.33%
        }
        .col8 {
            width: 66.66%
        }
        .col9 {
            width: 75%
        }
        .col10 {
            width: 83.33%
        }
        .col11 {
            width: 91.66%
        }
        .col12 {
            padding: 0 15px;
            width: 100%
        }
        .text-center {
            text-align:center;
            }
        .logs-buttons a {
            margin-left:20px;
        }
       
        @media only screen and (max-width: 767px) {
            .post-type-shop_order .modal{
                background-color: rgba(0,0,0,0.5);
            }
            .post-type-shop_order.modal-open .modal-backdrop{
                display: none;
            }
            .post-type-shop_order.modal-open .modal-dialog{
                top:50px;
            }
        }
		</style>';

    }

    //Getting total products perpage
    public function GetTotalFeed($perpage)
    {
        global $wpdb;
        include_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
        $this->record       = $wpdb->get_results("select * from " . $wpdb->prefix . "license_key");
        $this->license_no   = $this->record[0]->license_no;
        $this->language     = $this->record[0]->language;
        $this->url          = $this->api_domain . "feeds/" . $this->domain . "/" . $this->license_no . "/feed/total?perpage=". $perpage;

        $this->ch = curl_init();
        curl_setopt($this->ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($this->ch, CURLOPT_URL, $this->url);
        $this->l_result = curl_exec($this->ch);
        curl_close($this->ch);
        $this->license_key_status = json_decode($this->l_result, true);

        return $this->license_key_status["pages"];

    }

    //Checking License Key is valid or not
    public function CheckLicenseKey($license_no, $domain)
    {
        $this->url = $this->api_domain . "feeds/" . $domain . "/" . $license_no . "/feed/total";

        $this->ch = curl_init();
        curl_setopt($this->ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($this->ch, CURLOPT_URL, $this->url);
        $this->l_result = curl_exec($this->ch);
        curl_close($this->ch);
        $this->license_key_status = json_decode($this->l_result, true);

        return $this->license_key_status;
    }

    //TOOLS Setup
    public function deleteEans(){
        include_once plugin_dir_path( dirname( __FILE__ ) ) . 'functions/dropship_tools.php';
        $dsp = new DropshipTools($this->data);
        echo json_encode($dsp->deleteEans());
        exit();
    }

    public function deleteAllEans(){
        include_once plugin_dir_path( dirname( __FILE__ ) ) . 'functions/dropship_tools.php';
        $dsp = new DropshipTools($this->data);
        echo json_encode($dsp->deleteAllEans());
        exit();
    }

    public function deleteAttr(){
        include_once plugin_dir_path( dirname( __FILE__ ) ) . 'functions/dropship_tools.php';
        $dsp = new DropshipTools($this->data);
        echo json_encode($dsp->deleteAttr());
        exit();
    }
    // END TOOLS

    //Sending site details to mantella
    public function sendinfotomantella(){
        include_once plugin_dir_path( dirname( __FILE__ ) ) . 'core/mantella_sendtoportal.php';
        $dsp = new DropshipSendtoPortal($this->data);
        $_SESSION['SEND_TO_PORTAL_MSG'] = $dsp->sendtoAPI();
        //var_dump($dsp->sendtoAPI());
        //echo'<hr>';
        //var_dump(json_encode($dsp->sendtoAPI()));
        echo json_encode($dsp->sendtoAPI());
        exit();
    }

    //sending data to portal
    public function sendinfotoPortal(){
        include_once plugin_dir_path( dirname( __FILE__ ) ) . 'core/mantella_sendtoportal.php';
        $dsp = new DropshipSendtoPortal($this->data);
        $dsp->sendtoAPI();
    }

    //Sending error email to mantella
    public function senderrortomantella(){
        include_once plugin_dir_path( dirname( __FILE__ ) ) . 'core/mantella_sendtoportal.php';
        $dsp = new DropshipSendtoPortal($this->data);
        echo json_encode($dsp->sendErrorEmail());
        exit();
    }

    //current import fetching record
    public function getImportedProductsStatus(){
        global $wpdb;
        
        $record = $wpdb->get_results("select perpage from " . $wpdb->prefix . "license_key");
        $page_number = $wpdb->get_var("SELECT page_no FROM " . $wpdb->prefix . "dropship_import_cron_dtl");
       
        $total_imported_count = "";
        if($page_number != '')
        { 
            $total_imported_count = $page_number* $record[0]->perpage;
        }
        echo json_encode($total_imported_count);
        exit();   
    }

    //checking cron process is working or not
    public function checkImportStatus(){
        global $wpdb;
               
        $dtlrecord = $wpdb->get_results("SELECT * FROM " . $wpdb->prefix . "dropship_import_cron_dtl");       
        
        $status_val = "In process...";
        if(count($dtlrecord) == 1)
        { 
            $past_time = date('h:i:s', strtotime($dtlrecord[0]->modified_on));        
            $past_time_stamp = strtotime($past_time);

            $cur_time_stamp = strtotime(date('h:i:s'));
            $total_minutes = round(($cur_time_stamp - $past_time_stamp) / 60);
        
            if ($total_minutes > 5)
            {
                $dropship_temp_table = $wpdb->prefix . "dropship_import_cron_dtl_temp";
                $dtltemprecord = $wpdb->get_results("SELECT * FROM " . $dropship_temp_table);  
                if(count($dtltemprecord) == 0)
                { 
                    $next_pages_value = $dtlrecord[0]->page_no+1;
                    $temptabledata = array(
                        'page_no'       => $next_pages_value, 
                        'created_on'    => date('Y-m-d h:i:s')
                    );                 

                    $wpdb->insert( $dropship_temp_table, $temptabledata);
                    $status_val = "Process stop";
                }
                
            }
        }
        echo json_encode($status_val);
        exit();   
    }

    //Showing Plugin Layout
    function dropship_platform()
    {
        global $wpdb;
        include_once( ABSPATH . 'wp-admin/includes/upgrade.php' );

        //Adding stylesheet
        wp_enqueue_style('_inc', plugins_url('/assets/layout.css', __FILE__));
        $this->record = $wpdb->get_results("select * from " . $wpdb->prefix . "license_key");

        //support
        $this->support_data = $wpdb->get_results("select * from " . $wpdb->prefix . "support");

        //Checking for domain API url is live or demo
        if($this->api_domain != 'https://portal.dropshiptool.eu/')
        {
            $this->domain_status_err_message = __('The plugin is connected to ', 'dropship-tool-by-mantella');
            echo '<div class="notice notice-error is-dismissible"><p>'. $this->domain_status_err_message . $this->api_domain . '</p></div>';

        }

        if (isset($_POST['save_perpage']))
        {
            $this->perpage = $_POST['perpage'];
            $this->total_feed = $this->GetTotalFeed($this->perpage);

            $this->sql_support = "UPDATE `" . $wpdb->prefix . "license_key` SET `total_feed`='". $this->total_feed ."', `perpage`='". $this->perpage ."' WHERE id=". $this->record[0]->id;
            $wpdb->query($this->sql_support);

            $this->save_msg = __('Saved successfully.', 'dropship-tool-by-mantella');
            $_SESSION['SAVEMSG'] = $this->save_msg;

            $this->record = $wpdb->get_results("SELECT * FROM " . $wpdb->prefix . "license_key");

        }

        if (isset($_POST['sendtoportal']))
        {
            include_once plugin_dir_path( dirname( __FILE__ ) ) . 'core/mantella_sendtoportal.php';
            $dsp = new DropshipSendtoPortal($this->data);
            $_SESSION['SEND_TO_PORTAL_MSG'] = $dsp->sendtoAPI();
            echo 'Submitted';
        }

        if (isset($_POST['add']))
        {
            $this->license_no = $_POST['key'];
            $this->license_key_status = $this->CheckLicenseKey($this->license_no, $this->domain);
            if(isset($this->license_key_status))
            {
                if(isset($this->license_key_status['access']) && $this->license_key_status['access']=='denied')
                {
                    $this->license_status = $this->license_key_status['reason'];
                    $this->license_status_err_message = __('Your Dropship Tool license key is invalid. Product stock will not be checked and product information will not be updated.', 'dropship-tool-by-mantella');
                    echo '<script>jQuery(document).ready(function(){ jQuery("#seterrmsgkey").show(); jQuery("#seterrmsgkey").fadeIn("slow").delay(20000).hide(0); });</script>';
                    //echo '<div class="notice notice-error is-dismissible"><p>'. $this->license_status_err_message . '</p></div>';

                }else{

                    $this->license_status = 'The license key is valid and active';

                }

            }else{
                $this->license_status = 'License key is blank';
                $this->license_status_err_message = __('Your Dropship Tool license key is invalid. Product stock will not be checked and product information will not be updated.', 'dropship-tool-by-mantella');
                echo '<script>jQuery(document).ready(function(){ jQuery("#seterrmsgkey").show(); jQuery("#seterrmsgkey").fadeIn("slow").delay(20000).hide(0); });</script>';
                //echo '<div class="notice notice-error is-dismissible"><p>'. $this->license_status_err_message . '</p></div>';
            }

            /** set per page amount on different time-vars */
            if($_POST['cron_repeat_time'] == 60 ){
                $this->perpage = 15;
            }else{
                $this->perpage = 10;
            }

            $this->stock_status                 = 'Yes';
            $this->prices_status                = (isset($_POST['prices_status']))?$_POST['prices_status']:'No';
            $this->categories_status            = (isset($_POST['categories_status']))?$_POST['categories_status']:'No';
            $this->allproduct_status            = (isset($_POST['allproduct_status']))?'Yes':'No';
            $this->time_var		                = (isset($_POST['time_var']))?$_POST['time_var']:'60';
            //$this->perpage                    = (isset($_POST['perpage']))?$_POST['perpage']:"10";
            $this->ean_show_in_front            = (isset($_POST['ean_show_in_front']))? $_POST['ean_show_in_front']:'No';
            $this->brand_show_in_front          = (isset($_POST['brand_show_in_front']))? $_POST['brand_show_in_front']:'No';
            $this->brand_with_title_status      = (isset($_POST['brand_with_title_status']))? $_POST['brand_with_title_status']:'No';
            $this->product_attributes_status    = (isset($_POST['product_attributes_status']))?$_POST['product_attributes_status']:'No';
            $this->title_status                 = (isset($_POST['title_status']))? $_POST['title_status']:'No';
            $this->language                     = (isset($_POST['language']))? $_POST['language']:'NL';

            if(!empty($this->stock_status) || !empty($this->prices_status) || !empty($this->categories_status) )
            {

                $this->ean = 'Yes';

            }else{

                $this->ean = 'No';

            }

            $array_list['stock_status']                     = $this->stock_status;
            $array_list['stock_status_update']              = (isset($_POST['stock_status_update']))?$_POST['stock_status_update']:'No';
            $array_list['prices_status']                    = $this->prices_status;
            $array_list['prices_status_update']             = (isset($_POST['prices_status_update']))?$_POST['prices_status_update']:'No';
            $array_list['categories_status']                = $this->categories_status;
            $array_list['categories_status_update']         = (isset($_POST['categories_status_update']))?$_POST['categories_status_update']:'No';
            $array_list['title_status']                     = $this->title_status;
            $array_list['title_status_update']              = (isset($_POST['title_status_update']))?$_POST['title_status_update']:'No';
            $array_list['url_status']                       = (isset($_POST['url_status']))?$_POST['url_status']:'No';
            $array_list['url_status_update']                = (isset($_POST['url_status_update']))?$_POST['url_status_update']:'No';
            $array_list['product_attributes_status']        = $this->product_attributes_status;
            $array_list['product_attributes_status_update'] = (isset($_POST['product_attributes_status_update']))?$_POST['product_attributes_status_update']:'No';
            $array_list['attribute_type']                   = (isset($_POST['attribute_type']))?$_POST['attribute_type']:'local';
            $array_list['description_status']               = (isset($_POST['description_status']))?$_POST['description_status']:'No';
            $array_list['description_status_update']        = (isset($_POST['description_status_update']))?$_POST['description_status_update']:'No';
            $array_list['shortdescription_status']          = (isset($_POST['shortdescription_status']))?$_POST['shortdescription_status']:'No';
            $array_list['shortdescription_status_update']   = (isset($_POST['shortdescription_status_update']))?$_POST['shortdescription_status_update']:'No';
            $array_list['shipping_class_status']            = (isset($_POST['shipping_class_status']))?$_POST['shipping_class_status']:'No';
            $array_list['shipping_class_status_update']     = (isset($_POST['shipping_class_status_update']))?$_POST['shipping_class_status_update']:'No';
            $array_list['brand_status']                     = (isset($_POST['brand_status']))?$_POST['brand_status']:'No';
            $array_list['brand_status_update']              = (isset($_POST['brand_status_update']))?$_POST['brand_status_update']:'No';
            $array_list['image_status']                     = (isset($_POST['image_status']))?$_POST['image_status']:'No';
            $array_list['image_status_update']              = (isset($_POST['image_status_update']))?$_POST['image_status_update']:'No';
            $array_list['allproduct_status']                = (isset($_POST['allproduct_status']))?$_POST['allproduct_status']:'No';
            $array_list['allproduct_status_update']         = (isset($_POST['allproduct_status_update']))?$_POST['allproduct_status_update']:'No';
            $array_list['added_product_status']             = (isset($_POST['added_product_status']))?$_POST['added_product_status']:'publish';
            $array_list['cron_repeat_time']                 = (isset($_POST['cron_repeat_time']))?$_POST['cron_repeat_time']:'20';
            $array_list['store_brand_as_attribute']         = (isset($_POST['store_brand_as_attribute']))?$_POST['store_brand_as_attribute']:'No';
            $array_list['store_brand_as_attribute_update']  = (isset($_POST['store_brand_as_attribute_update']))?$_POST['store_brand_as_attribute_update']:'No';
            $array_list['attr_choose']                      = (isset($_POST['attr_choose']))? $_POST['attr_choose']:'No';
            $array_list['custom_attributes']                = strtolower((isset($_POST['custom_attributes']))? $_POST['custom_attributes']:'');

            $import_update_data = serialize($array_list);

            if($array_list['brand_status'] == 'No')
            {
                $this->brand_show_in_front  = 'No';
            }

            if (isset($this->record[0]))
            {
                global $wpdb;
                $this->table_name = $wpdb->prefix.'license_key';
                $this->data_update = array(
                    'license_no'	 	=> $this->license_no,
                    'ean_code'	 		=> $this->ean,
                    'stock_status' 		=> $this->stock_status,
                    'prices_status' 	=> $this->prices_status,
                    'categories_status' => $this->categories_status,
                    'allproduct_status' => $this->allproduct_status,
                    'language' 			=> $this->language,
                    'ean_show_in_front' => $this->ean_show_in_front,
                    'license_status' 	=> $this->license_status,
                    'time_var' 			=> $this->time_var,
                    'perpage'           => $this->perpage,
                    'brand_show_in_front' => $this->brand_show_in_front,
                    'brand_with_title_status' => $this->brand_with_title_status,
                    'product_attributes_status' => $this->product_attributes_status,
                    'title_status' => $this->title_status,
                    'import_settings' => $import_update_data
                );

                $this->data_where = array('id'=>$this->record[0]->id);
                $wpdb->update($this->table_name , $this->data_update, $this->data_where);

            } else {

                $wpdb->insert($wpdb->prefix . "license_key",
                    array(
                        'license_no' 		=> $this->license_no,
                        'ean_code'	 		=> $this->ean,
                        'stock_status' 		=> $this->stock_status,
                        'prices_status' 	=> $this->prices_status,
                        'categories_status' => $this->categories_status,
                        'allproduct_status' => $this->allproduct_status,
                        'language' 			=> $this->language,
                        'ean_show_in_front' => $this->ean_show_in_front,
                        'license_status' 	=> $this->license_status,
                        'time_var' 			=> $this->time_var,
                        'perpage'           => $this->perpage,
                        'brand_show_in_front' => $this->brand_show_in_front,
                        'brand_with_title_status' => $this->brand_with_title_status,
                        'product_attributes_status' => $this->product_attributes_status,
                        'title_status' => $this->title_status,
                        'import_settings' => $import_update_data
                    )
                );

            }
            
            //data send to portal to update shop info
            $this->sendinfotoPortal();
            $this->record = $wpdb->get_results("SELECT * FROM " . $wpdb->prefix . "license_key");

        }

        if (isset($_POST['import_product']))
        {
            include_once plugin_dir_path( dirname( __FILE__ ) ) . 'core/wp-product-import.php';
            $dpi = new DropshipProductImport($this->data);

            $this->record = $wpdb->get_results("SELECT * FROM " . $wpdb->prefix . "license_key");
            $this->license_no = $this->record[0]->license_no;
            $this->c_rec = $wpdb->get_results("SELECT count(*) as tot FROM " . $wpdb->prefix . "dropship_import_cron_dtl");
            $this->count = $this->c_rec[0]->tot;
            $this->perpage =$this->record[0]->perpage;

            //Check if there is a current import running
            if($this->count > 0)
            {
                $this->count_msg = __('there is already an import running in the background.', 'dropship-tool-by-mantella');
                $_SESSION['PROMSG'] = $this->count_msg;

            } else {

                //Add total feed in table
                $this->url = $this->api_domain . "feeds/" . $this->domain . "/" . $this->license_no . "/feed/total?perpage=".$this->perpage;

                $this->ch = curl_init();
                curl_setopt($this->ch, CURLOPT_RETURNTRANSFER, 1);
                curl_setopt($this->ch, CURLOPT_URL, $this->url);
                $this->outer_result = curl_exec($this->ch);
                curl_close($this->ch);
                $this->outer_json = json_decode($this->outer_result, true);
                $this->total_feed = $this->outer_json['pages'];

                $this->sql_support = $wpdb->prepare("UPDATE `" . $wpdb->prefix . "license_key` SET `total_feed`='". $this->total_feed ."' WHERE id=%d",$this->record[0]->id);
                $wpdb->query($this->sql_support);

                //insert a row with pagenumber is 1 in both tables
                $this->created_on	= date("Y-m-d H:i:s");

                $wpdb->insert($wpdb->prefix . "dropship_import_cron_dtl_temp",
                    array(
                        'page_no'		=> 1,
                        'created_on' 	=> $this->created_on
                    )
                );

                $wpdb->insert($wpdb->prefix . "dropship_import_cron_dtl",
                    array(
                        'page_no'		=> 1,
                        'created_on' 	=> $this->created_on
                    )
                );

                $dpi->mantella_cron_productimport_function_now();

                $this->count_msg2 = __('The import will start soon. It can take some time for it to finish. Please be patient', 'dropship-tool-by-mantella');

                $_SESSION['PROMSG'] = $this->count_msg2;
              
                $this->checkImportStatusInTable();
                $this->callImportStatusScript($this->perpage);
            }

        }

        if (isset($_POST['stop_import']))
        {
            $this->sql_del = "DELETE FROM `" . $wpdb->prefix . "dropship_import_cron_dtl`";
            $wpdb->query($this->sql_del);

            $this->sql_del2 = "DELETE FROM `" . $wpdb->prefix . "dropship_import_cron_dtl_temp`";
            $wpdb->query($this->sql_del2);
            //record inserted into log 
            include_once plugin_dir_path( dirname( __FILE__ ) ) . 'core/wp-product-import.php';
            $dpi = new DropshipProductImport($this->data);
            $log_status = 'stop_import';
            $dpi->logImportedData($log_status, '', '', '', '', '');

            $this->count_msg3 = "";
            $_SESSION['PROMSG'] = $this->count_msg3;

        }

        //support
        if (isset($_POST['suport_add']))
        {
            $this->title = $_POST['title'];
            $this->description = $_POST['description'];
            if (isset($this->support_data[0]))
            {
                $this->sql_support = $wpdb->prepare("UPDATE `" . $wpdb->prefix . "support` SET `title`='$this->title', `description`='$this->description' WHERE id=1");
                $wpdb->query($this->sql_support);

            } else {

                $this->sql_support = $wpdb->prepare("INSERT INTO `" . $wpdb->prefix . "support`(`title`,`description`) values('$this->title', '$this->description')");
                $wpdb->query($this->sql_support);
            }

            $wpdb->get_results("SELECT * FROM " . $wpdb->prefix . "support");

            $this->support_msg = "<div class='alert alert-success' role='alert'>
			<strong>Well done!</strong> Support Successfuly Submited.
			</div>";

            $_SESSION['SUPMSG'] = $this->support_msg;

        }

        $this->logo_img = plugin_dir_url(__FILE__) . 'assets/dropshiptool-by-mantella-logo.png';

        ?>
        <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css" crossorigin="anonymous">
        <link href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css"  rel="stylesheet">

        <!-- Latest compiled JavaScript -->
        <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" crossorigin="anonymous"></script>
        <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js" crossorigin="anonymous"></script>
        <script>
            jQuery(function () {
                jQuery('[data-toggle="tooltip"]').tooltip()
            })

            jQuery(document).ready(function(){
                var updatekeystatus = jQuery('#Updateinputname').val();
                var insertkeystatus = jQuery('#Insertinputname').val();
                if(updatekeystatus){
                    jQuery('.warnmsg').removeClass("clserror");
                }
                if(insertkeystatus){
                    jQuery('.warnmsg').removeClass("clserror");
                }

                jQuery('#Updateinputname').blur(function(){
                    var updatekeystatusb = jQuery('#Updateinputname').val();
                    if(!updatekeystatusb){
                        jQuery('.warnmsg').addClass("clserror");
                    }else{
                        jQuery('.warnmsg').removeClass("clserror");
                    }
                });

                //general tab messages
                jQuery('#gensucmessage').hide();
                jQuery('#generrmessage').hide();
                jQuery('#generalbtn').click(function(){
                    jQuery('#gensucmessage').show();
                    jQuery('#gensucmessage').fadeIn('slow').delay(50000).hide(0);
                });

                //settings tab messages
                jQuery('#setsucmsg').hide();
                jQuery('#setsucmsg2').hide();
                jQuery('#seterrmsg').hide();
                jQuery('#settingsbtn').click(function(){
                    jQuery('#setsucmsg').show();
                    jQuery('#setsucmsg').fadeIn('slow').delay(50000).hide(0);
                });

                //support tab messages
                jQuery('#supsucmsg').hide();

                //Showing active tab after refresh
                jQuery('a[data-toggle="tab"]').on('show.bs.tab', function(e) {
                    localStorage.setItem('activeTab', jQuery(e.target).attr('href'));
                });

                var activeTab = localStorage.getItem('activeTab');
                if(activeTab){
                    jQuery('#pluginTab a[href="' + activeTab + '"]').tab('show');
                }

                //Form validation showing
                jQuery("#UpdateForm").submit(function(event) {
                    jQuery('.content_brand_title').hide();
                    var vForm = jQuery(this);
                    if (vForm[0].checkValidity() === false) {
                        event.preventDefault()
                        event.stopPropagation()
                    } else {
                        //alert("your form is valid and ready to send");
                    }
                    vForm.addClass('was-validated');
                });

                jQuery("#InsertForm").submit(function(event) {
                    jQuery('.content_brand_title').hide();
                    var vForm = jQuery(this);
                    if (vForm[0].checkValidity() === false) {
                        event.preventDefault()
                        event.stopPropagation()
                    } else {
                        //alert("your form is valid and ready to send");
                    }
                    vForm.addClass('was-validated');
                });

            });

        </script>

        <div id="exTab2" class="container">
            <h4>
                <img src="<?php echo $this->logo_img; ?>" style="max-width: 300px; height: auto;" alt="<?php echo __('Dropship tool', 'dropship-tool-by-mantella'); ?>" title="<?php echo __('Dropship tool by dropshiptool', 'dropship-tool-by-mantella'); ?>">
            </h4>
            <div class="site_tab">
                <ul class="nav nav-tabs" id="pluginTab" role="tablist">
                    <?php if($this->record[0]->license_status=='The license key is valid and active'){ ?>
                        <li class="nav-item"><a href="#general" class="nav-link" data-toggle="tab" aria-selected="false"><i class="fa fa-rocket"></i> <?php echo __('General', 'dropship-tool-by-mantella'); ?></a></li>
                    <?php } ?>
                    <li class="nav-item"><a href="#settings" class="nav-link active" data-toggle="tab" aria-selected="true"> <i class="fa fa-gears"></i> <?php echo __('Settings', 'dropship-tool-by-mantella'); ?></a></li>
                    <li class="nav-item"><a href="#logs" class="nav-link" data-toggle="tab" aria-selected="true"> <i class="fa fa-file"></i> <?php echo __('Logs', 'dropship-tool-by-mantella'); ?></a></li>
                    <li class="nav-item"><a href="#tools" class="nav-link" data-toggle="tab" aria-selected="true"> <i class="fa fa-wrench"></i> <?php echo __('Tools', 'dropship-tool-by-mantella'); ?></a></li>
                    <li class="nav-item"><a href="#support" class="nav-link" data-toggle="tab" aria-selected="false"> <i class="fa fa-comment"></i> <?php echo __('Support', 'dropship-tool-by-mantella'); ?></a></li>
                </ul>
            </div>

            <div class="tab-content">

                <?php
                if($this->record[0]->license_status!='The license key is valid and active')
                    {
                        if($this->license_status_err_message)
                        {
                            echo '<div class="notice notice-error is-dismissible" style="margin:0px;"><p>'. $this->license_status_err_message . '</p></div><br/>';
                        }
                    }
                ?>

                <!-- #general start -->
                <?php include_once('tabs/general.php'); ?>

                <!-- #settings starts -->
                <?php include_once('tabs/settings.php'); ?>

                <!-- #logs start -->
                <?php include_once('tabs/logs.php'); ?>

                <!-- #tools start -->
                <?php include_once('tabs/tools.php'); ?>

                <!-- #support start -->
                <?php include_once('tabs/support.php'); ?>
            </div>
        </div> <!-- #exTab2 end-->
        <?php
    } 
  
    //This function is used to check record in every 5 minutes
    public function checkImportStatusInTable()
    {
        ?>
        <script>

            setInterval(check_Import_Status, 300000);

            function check_Import_Status(){  
              var ajaxurl ="<?php echo admin_url( 'admin-ajax.php' ); ?>";
                jQuery.ajax({
                    type: "post",
                    dataType: "json",
                    url: ajaxurl,
                    data: {
                      "action": "check_import_status"
                       },
                    success:function(response) {
                       
                        var responsedata = JSON.parse(JSON.stringify(response));
                        if(responsedata){
                          console.log('done');
                          }
                        
                    },
                    error: function(errorThrown){
                        console.log(errorThrown);
                    }
                });                

            }
            //ajax sending error email to mantella
            jQuery("#send_error_to_mantella").click(function () {

                console.log('yes!');
                var ajaxurl ="<?php echo admin_url( 'admin-ajax.php' ); ?>";
                jQuery.ajax({
                    type: "post",
                    dataType: "json",
                    url: ajaxurl,
                    data: {
                        "action": "send_error_to_mantella"
                    },
                    success:function(resp) {
                        //alert(resp);
                        //var respdatas = JSON.parse(JSON.stringify(resp));
                        if(resp==='mail sent') {
                            jQuery('#logsuccmsg').show();
                            jQuery('#logsuccmsg').fadeIn('slow').delay(50000).hide(0);
                        }
                    },
                    error: function(errorThrown){
                        console.log(errorThrown);
                    }
                });
            });
        </script>

        <?php
  }          
  
    //This function is used to replace the import message and products
    public function callImportStatusScript($timeinterval)
    {
        $interval_values = $timeinterval*2;
        ?>
        <script>

            setInterval(get_Product_Import_Status, '<?php echo $interval_values.'000'; ?>');

            function get_Product_Import_Status(){  
                var ajaxurl ="<?php echo admin_url( 'admin-ajax.php' ); ?>";
                jQuery.ajax({
                    type: "post",
                    dataType: "json",
                    url: ajaxurl,
                    data: {
                      "action": "get_imported_products_status"
                       },
                    success:function(response) {
                        var responsedata = JSON.parse(JSON.stringify(response));
                        if(responsedata){
                           jQuery("#sofar_products_count").text(responsedata);
                        }else{
                            location.reload();
                        }
                    },
                    error: function(errorThrown){
                        console.log(errorThrown);
                    }
                });                

            }
        </script>

        <?php
    }
}
