<style>
    .list-logs {
        list-style: none;
        padding:0;
        margin:0;
    }
    .list-logs li {
        display:flex;
        padding:10px 15px;
        border-bottom: 1px solid #f1f1f1;
        margin:0;
    }
    .list-logs li:last-child {
        border:none;
        padding-bottom:0;
    }
    .list-logs li:hover {
        background:#f1f1f1;
    }
    .list-logs li .logs-icon {
        min-width:30px;
        width:30px;
        color: #000000;
        font-size:20px;
    }
    .logs-title {
        color: #000000;
        font-size: 15px;
        font-weight: 400;
    }
    .logs-date{
        color: #8a8a8a;
        font-size: 13px;
        font-weight: 400;
    }
</style>
<div id="logs" class="tab-pane fade">
    <div id="logsuccmsg" class="alert alert-success alert-dismissible fade show" role="alert" style="display:none;">
        <strong><?php echo __('Succes!', 'dropship-tool-by-mantella'); ?></strong> <?php echo __('Data received by dropshiptool.', 'dropship-tool-by-mantella'); ?>
        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <?php
    if( isset($_GET['log']) && $_GET['log'])
        $log_value = $_GET['log'];
    else
        $log_value = 'all';

    if( $log_value == 'tools')
        $errorrecord = $wpdb->get_results("select * from " . $wpdb->prefix . "dropship_track_logs WHERE log_date > (now() - INTERVAL 72 HOUR) AND log_type = 'tools_function_delete_product' Order By id DESC LIMIT 2000");
    else if( $log_value == 'cron')
        $errorrecord = $wpdb->get_results("select * from " . $wpdb->prefix . "dropship_track_logs WHERE log_date > (now() - INTERVAL 72 HOUR) AND log_type = 'cronjob_functions' Order By id DESC LIMIT 2000");
    else if( $log_value == 'manual')
        $errorrecord = $wpdb->get_results("select * from " . $wpdb->prefix . "dropship_track_logs WHERE log_date > (now() - INTERVAL 72 HOUR) AND log_type = 'manual_import' Order By id DESC LIMIT 2000");
    else
        $errorrecord = $wpdb->get_results("select * from " . $wpdb->prefix . "dropship_track_logs WHERE log_date > (now() - INTERVAL 72 HOUR) Order By id DESC LIMIT 2000");


    ?>
    <div class="tab-inner-content">
        <div class="tab-summery">
            <div class="row">
                <div class="col-md-6">
                    <h5><?php echo  __('Logs', 'dropship-tool-by-mantella');
                        if( $log_value == 'tools')
                            echo  __(' Tool Functions', 'dropship-tool-by-mantella');
                        else if( $log_value == 'cron')
                            echo  __(' Automatic updates', 'dropship-tool-by-mantella');
                        else if( $log_value == 'manual')
                            echo  __(' Import/ update batches', 'dropship-tool-by-mantella');
                    ?>
                    </h5>
                </div>
                <div class="col-md-6">
                    <div class="d-flex justify-content-end logs-buttons">
                        <select  id="dropdown" onchange="reloadPage()">
                            <option value="admin.php?page=mantella&log=all"     <?php if( $log_value == 'all')    { echo 'selected'; } ?>><?php echo  __('Show all logs', 'dropship-tool-by-mantella'); ?></option>
                            <option value="admin.php?page=mantella&log=manual"  <?php if( $log_value == 'manual') { echo 'selected'; } ?>><?php echo  __('Manual import/update', 'dropship-tool-by-mantella'); ?></option>
                            <option value="admin.php?page=mantella&log=cron"    <?php if( $log_value == 'cron')   { echo 'selected'; } ?>><?php echo  __('Automatic updates', 'dropship-tool-by-mantella'); ?></option>
                            <option value="admin.php?page=mantella&log=tools"   <?php if( $log_value == 'tools')  { echo 'selected'; } ?>><?php echo  __('Tool logs', 'dropship-tool-by-mantella'); ?></option>
                        </select>

                        <script type="text/javascript">
                            function reloadPage(){
                                var dropdown2 = document.getElementById('dropdown');
                                window.location.href = dropdown.value;
                            }
                        </script>
                    </div>
                </div>
            </div>

            <hr class="mb-4">
            <?php if(count($errorrecord) > 0){ ?>
                <div class="row">
                    <div class="col-sm-12">
                        <ul class="list-logs">
                            <?php foreach($errorrecord as $edata){ ?>

                                <?php if($edata->log_status == 'Cron start'){ ?>
                                    <li class="list-logs-item">
                                        <div class="logs-icon"><i style="color: #0086f6;" class="fa fa-edit"></i></div>
                                        <div class="logs-summery">
                                            <div class="logs-title"><?php echo __('Cronjob product update started. A total of ', 'dropship-tool-by-mantella'); ?> <strong><?php echo $edata->total_batches;?></strong> <?php echo __('batches will be imported.', 'dropship-tool-by-mantella'); ?></div>
                                            <div class="logs-date"><?php echo date("d-m-Y h:i:s", strtotime($edata->log_date));?></div>
                                        </div>
                                    </li>
                                <?php } ?>
                                <?php if($edata->log_status == 'Cron end'){ ?>
                                    <li class="list-logs-item">
                                        <div class="logs-icon"><i style="color: #3fb800;" class="fa fa-check"></i></div>
                                        <div class="logs-summery">
                                            <div class="logs-title"><?php echo __('Cronjob product update ended. ', 'dropship-tool-by-mantella'); ?> <strong><?php echo $edata->total_imported_products;?> </strong><?php echo __('products updated', 'dropship-tool-by-mantella'); ?></div>
                                            <div class="logs-date"><?php echo date("d-m-Y h:i:s", strtotime($edata->log_date));?></div>
                                        </div>
                                    </li>
                                <?php } ?>

                                <?php if($edata->log_status == 'Import finished'){ ?>
                                    <li class="list-logs-item">
                                        <div class="logs-icon"><i style="color: #3fb800;" class="fa fa-check"></i></div>
                                        <div class="logs-summery">
                                            <div class="logs-title"><?php echo __('Import finished', 'dropship-tool-by-mantella'); ?></div>
                                            <div class="logs-date"><?php echo date("d-m-Y h:i:s", strtotime($edata->log_date));?></div>
                                        </div>
                                    </li>
                                <?php } ?>
                                <?php if($edata->log_status == 'stop_import'){ ?>
                                    <li class="list-logs-item">
                                        <div class="logs-icon"><i class="fa fa-tasks"></i></div>
                                        <div class="logs-summery">
                                            <div class="logs-title"><?php echo __('Manually stopped the import', 'dropship-tool-by-mantella'); ?></div>
                                            <div class="logs-date"><?php echo date("d-m-Y h:i:s", strtotime($edata->log_date));?></div>
                                        </div>
                                    </li>
                                <?php } ?>

                                <?php if(($edata->per_batch_imported != '' || $edata->per_batch_updated != '') && $edata->log_status != 'stop_import'){
                                    $imported_arr = json_decode($edata->per_batch_imported);
                                    $updated_arr = json_decode($edata->per_batch_updated);
                                    ?>
                                    <li class="list-logs-item">
                                        <div class="logs-icon"><i class="fa fa-tasks"></i></div>
                                        <div class="logs-summery">
                                            <div class="logs-title">
                                                <?php echo __('Import batch nr.', 'dropship-tool-by-mantella'); ?> <strong><?php echo $edata->batch_number;?></strong> <?php echo __('done.', 'dropship-tool-by-mantella'); ?> <strong><?php echo $edata->total_imported_products;?></strong> <?php echo __('product imported', 'dropship-tool-by-mantella'); ?> <?php if($edata->log_text){ echo $edata->log_text;}else{ ?><strong>0</strong> <?php echo __('errors', 'dropship-tool-by-mantella'); ?><?php } ?></div>
                                            <div class="logs-title"><strong><?php if($edata->per_batch_imported){ echo count($imported_arr);?></strong> <?php echo __('Imported', 'dropship-tool-by-mantella'); ?> <?php } if($edata->per_batch_imported && $edata->per_batch_updated){ ?> <?php echo __('and', 'dropship-tool-by-mantella'); ?> <?php } ?><strong><?php if($edata->per_batch_updated){ echo count($updated_arr);?></strong> <?php echo __('updated.', 'dropship-tool-by-mantella'); ?><?php } ?></div>
                                            <div class="logs-date"><?php echo date("d-m-Y h:i:s", strtotime($edata->log_date));?></div>
                                        </div>
                                    </li>
                                <?php } ?>
                                <?php
                                if($edata->log_status == 'Import started'){
                                    ?>
                                    <li class="list-logs-item">
                                        <div class="logs-icon"><i style="color: #0086f6;" class="fa fa-file-o"></i></div>
                                        <div class="logs-summery">
                                            <div class="logs-title"><?php echo __('Import started. in total', 'dropship-tool-by-mantella'); ?> <strong><?php echo $edata->total_batches;?></strong> <?php echo __('batches will be imported', 'dropship-tool-by-mantella'); ?></div>
                                            <div class="logs-date"><?php echo date("d-m-Y h:i:s", strtotime($edata->log_date));?></div>
                                        </div>
                                    </li>
                                <?php } ?>


                                <?php
                                /** Get logs for product deletion */

                                if($edata->log_type == 'tools_function_delete_product'){ ?>
                                    <li class="list-logs-item">
                                        <?php if($edata->log_status == 'product_deleted'){ ?>
                                            <div class="logs-icon"><i style="color: #ff0000;" class="fa fa-times"></i></div>
                                        <?php } else if($edata->log_status == 'delete_batch_started'){  ?>
                                            <div class="logs-icon"><i style="color: #0086f6;" class="fa fa-file-o"></i></div>
                                        <?php } else { ?>
                                            <div class="logs-icon"><i style="color: #3fb800;" class="fa fa-check"></i></div>
                                        <?php  } ?>
                                        <div class="logs-summery">
                                            <div class="logs-title"><?php echo $edata->log_text; ?> </div>
                                            <div class="logs-date"><?php echo date("d-m-Y h:i:s", strtotime($edata->log_date));?></div>
                                        </div>
                                    </li>
                                <?php } ?>

                            <?php } ?>
                        </ul>
                    </div>
                </div>
            <?php } ?>
        </div>
    </div>
</div>